Package: NLP
Version: 0.3-2
Title: Natural Language Processing Infrastructure
Authors@R: person("Kurt", "Hornik", role = c("aut", "cre"),
                  email = "Kurt.Hornik@R-project.org",
		  comment = c(ORCID = "0000-0003-4198-9911"))
Description: Basic classes and methods for Natural Language Processing.
License: GPL-3
Imports: utils
Depends: R (>= 3.5.0)
Enhances: udpipe, spacyr, cleanNLP
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2024-11-20 07:53:13 UTC; hornik
Author: Kurt Hornik [aut, cre] (<https://orcid.org/0000-0003-4198-9911>)
Maintainer: Kurt Hornik <Kurt.Hornik@R-project.org>
Repository: CRAN
Date/Publication: 2024-11-20 08:04:45 UTC
Built: R 4.6.0; ; 2026-04-25 16:16:06 UTC; unix

Package: NLP
Version: 0.3-3
Title: Natural Language Processing Infrastructure
Authors@R: person("Kurt", "Hornik", role = c("aut", "cre"),
                  email = "Kurt.Hornik@R-project.org",
		  comment = c(ORCID = "0000-0003-4198-9911"))
Description: Basic classes and methods for Natural Language Processing.
License: GPL-3
Imports: utils
Depends: R (>= 3.5.0)
Enhances: udpipe, spacyr, cleanNLP
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2026-07-13 09:23:30 UTC; hornik
Author: Kurt Hornik [aut, cre] (ORCID: <https://orcid.org/0000-0003-4198-9911>)
Maintainer: Kurt Hornik <Kurt.Hornik@R-project.org>
Repository: CRAN
Date/Publication: 2026-07-13 09:45:34 UTC

   _   _ _     ____  
  | \ | | |   |  _ \ 
  |  \| | |   | |_) |
  | |\  | |___|  __/ 
  |_| \_|_____|_|    
                   
  NLP -- New LP, a frontend for PostScript printers                

  Version 3.0.2 (26-02-1997)

  NLP is a frontend to PostScript printers which can be controlled by the
  lpr/lp Unix commands. It recognizes ASCII, DVI, PDF and PostScript as the
  input file format and always generates pure PostScript as the output file
  format. The highlights of NLP are its additive manipulation options which
  can be applied for each input file. They control how the input format is
  converted to PostScript.

  The documentation and latest release can be found on
  http://www.engelschall.com/sw/nlp/

  Copyright (c) 1992-1997 Ralf S. Engelschall, All rights reserved.

  Look at the file LICENSE for detailed license 
  information about this product.

# HuggingFace Datasets

API proposal

```python
import datasets

dataset = datasets.load('squad')

print(dataset[0]). # Behave like a list - under the hook it's zero-copy reading from the disk
>>> {"id": "00990",
     "question": "Where is Boddy?",
     "context": "Bobby was at the beach",
     "answers": [{"text": "at the beach", "answer_start": 10}]
    }

# This dataset (SQuAD) is provided as just text data
# Let's encode it in model inputs
# We supply an encode examples or encode batch method
from transformers import BertTokenizer
tokenizer = BertTokenizer.from_pretrained('bert-base-cased')
def encode_example(example):
    encoding = tokenizer.encode_plus(example.context,
                                     example.question,
                                     return_tensors='pt')
    start_span = 
    end_span = 
    return dict(**encodings, {'start_span': start_span, 'end_span': end_span})

dataset.map_examples(encode_example)  # Lazy map
dataset.save('./data_cache')  # Caching on drive

dataset.get_torch_dataloader()  # Get a dataloader

# This download the dataset processing script
dataset_builder = datasets.builder('squad')
# This download the datasets files and preprocess them
dataset_builder.download_and_prepare()
# Then three options to access:
tf_dataset = dataset_builder.as_tf_dataset()  # Gives a TF Dataset (which is a PT Dataloader)
torch_dataset = dataset_builder.as_torch_dataset()
torch_dataloader = dataset_builder.as_torch_dataloader()

print(dataset[0])
>>> {"id": "00990",
     "question": "Where is Boddy?",
     "context": "Bobby was at the beach",
     "answers": [{"text": "at the beach", "answer_start": 10}]
    }

dataset.as_dataset()
```





# TensorFlow Datasets

TensorFlow Datasets provides many public datasets as `tf.data.Datasets`.

[![Kokoro](https://storage.googleapis.com/tfds-kokoro-public/kokoro-build.svg)](https://storage.googleapis.com/tfds-kokoro-public/kokoro-build.html)
[![PyPI version](https://badge.fury.io/py/tensorflow-datasets.svg)](https://badge.fury.io/py/tensorflow-datasets)

* [List of datasets](https://www.tensorflow.org/datasets/catalog/overview)
* Getting started:
  * [Introduction](https://www.tensorflow.org/datasets/overview) ([Try it in Colab](https://colab.research.google.com/github/tensorflow/datasets/blob/master/docs/overview.ipynb))
  * [End-to-end example with Keras](https://colab.research.google.com/github/tensorflow/datasets/blob/master/docs/keras_example.ipynb)
* Features & performances:
  * [Using splits and slicing API](https://www.tensorflow.org/datasets/splits)
  * [Performance advice](https://www.tensorflow.org/datasets/performances)
  * [Datasets versioning](https://www.tensorflow.org/datasets/datasets_versioning)
  * [Feature decoding](https://www.tensorflow.org/datasets/decode)
  * [Store your dataset on GCS](https://www.tensorflow.org/datasets/gcs)
* Add your dataset:
  * [Add a dataset](https://www.tensorflow.org/datasets/add_dataset)
  * [Add a huge dataset with Beam (>>100GiB)](https://www.tensorflow.org/datasets/beam_datasets)
* [API docs](https://www.tensorflow.org/datasets/api_docs/python/tfds)

Note: [`tf.data`](https://www.tensorflow.org/guide/data) is a builtin library in
TensorFlow which builds efficient data pipelines.
[TFDS](https://www.tensorflow.org/datasets) (this library) uses `tf.data` to
build an input pipeline when you load a dataset.

**Table of Contents**

* [Installation](#installation)
* [Usage](#usage)
* [`DatasetBuilder`](#datasetbuilder)
* [NumPy usage with `tfds.as_numpy`](#numpy-usage-with-tfdsasnumpy)
* [Citation](#citation)
* [Want a certain dataset?](#want-a-certain-dataset)
* [*Disclaimers*](#disclaimers)

### Installation

```sh
pip install tensorflow-datasets

# Requires TF 1.5+ to be installed.
# Some datasets require additional libraries; see setup.py extras_require
pip install tensorflow
# or:
pip install tensorflow-gpu
```

Join [our Google group](https://groups.google.com/forum/#!forum/tensorflow-datasets-public-announce)
to receive updates on the project.

### Usage

```python
import tensorflow_datasets as tfds
import tensorflow as tf

# Here we assume Eager mode is enabled (TF2), but tfds also works in Graph mode.

# Construct a tf.data.Dataset` or `torch.utils.data.DataLoader
ds_train = tfds.load('mnist', split='train', shuffle_files=True)

# Build your input pipeline
ds_train = ds_train.shuffle(1000).batch(128).prefetch(10)
for features in ds_train.take(1):
  image, label = features['image'], features['label']
```

Try it interactively in a
[Colab notebook](https://colab.research.google.com/github/tensorflow/datasets/blob/master/docs/overview.ipynb).

### `DatasetBuilder`

All datasets are implemented as subclasses of `tfds.core.DatasetBuilder`. TFDS
has two entry points:

*   `tfds.builder`: Returns the `tfds.core.DatasetBuilder` instance, giving
     control over `builder.download_and_prepare()` and
     `builder.as_dataset()`.
*   `tfds.load`: Convenience wrapper which hides the `download_and_prepare` and
    `as_dataset` calls, and directly returns the `tf.data.Dataset` or `torch.utils.data.DataLoader`.

```python
import tensorflow_datasets as tfds

# The following is the equivalent of the `load` call above.

# You can fetch the DatasetBuilder class by string
mnist_builder = tfds.builder('mnist')

# Download the dataset
mnist_builder.download_and_prepare()

# Construct a tf.data.Dataset` or `torch.utils.data.DataLoader
ds = mnist_builder.as_dataset(split='train')

# Get the `DatasetInfo` object, which contains useful information about the
# dataset and its features
info = mnist_builder.info
print(info)
```

This will print the dataset info content:

```
tfds.core.DatasetInfo(
    name='mnist',
    version=1.0.0,
    description='The MNIST database of handwritten digits.',
    homepage='http://yann.lecun.com/exdb/mnist/',
    features=FeaturesDict({
        'image': Image(shape=(28, 28, 1), dtype=tf.uint8),
        'label': ClassLabel(shape=(), dtype=tf.int64, num_classes=10)
    },
    total_num_examples=70000,
    splits={
        'test': <tfds.core.SplitInfo num_examples=10000>,
        'train': <tfds.core.SplitInfo num_examples=60000>
    },
    supervised_keys=('image', 'label'),
    citation='"""
        @article{lecun2010mnist,
          title={MNIST handwritten digit database},
          author={LeCun, Yann and Cortes, Corinna and Burges, CJ},
          journal={ATT Labs [Online]. Available: http://yann.lecun.com/exdb/mnist},
          volume={2},
          year={2010}
        }
    """',
)
```

You can also get details about the classes (number of classes and their names).

```python
info = tfds.builder('cats_vs_dogs').info

info.features['label'].num_classes  # 2
info.features['label'].names  # ['cat', 'dog']
info.features['label'].int2str(1)  # "dog"
info.features['label'].str2int('cat')  # 0
```

### NumPy Usage with `tfds.as_numpy`

As a convenience for users that want simple NumPy arrays in their programs, you
can use `tfds.as_numpy` to return a generator that yields NumPy array
records out of a `tf.data.Dataset` or `torch.utils.data.DataLoader`. This allows you to build high-performance
input pipelines with `tf.data` but use whatever you'd like for your model
components.

```python
train_ds = tfds.load("mnist", split="train")
train_ds = train_ds.shuffle(1024).batch(128).repeat(5).prefetch(10)
for example in tfds.as_numpy(train_ds):
  numpy_images, numpy_labels = example["image"], example["label"]
```

You can also use `tfds.as_numpy` in conjunction with `batch_size=-1` to
get the full dataset in NumPy arrays from the returned `tf.Tensor` object:

```python
train_ds = tfds.load("mnist", split=tfds.Split.TRAIN, batch_size=-1)
numpy_ds = tfds.as_numpy(train_ds)
numpy_images, numpy_labels = numpy_ds["image"], numpy_ds["label"]
```

Note that the library still requires `tensorflow` as an internal dependency.

### Citation

Please include the following citation when using `tensorflow-datasets` for a
paper, in addition to any citation specific to the used datasets.

```
@misc{TFDS,
  title = {{TensorFlow Datasets}, A collection of ready-to-use datasets},
  howpublished = {\url{https://www.tensorflow.org/datasets}},
}
```

## Want a certain dataset?

Adding a dataset is really straightforward by following
[our guide](https://github.com/tensorflow/datasets/tree/master/docs/add_dataset.md).

Request a dataset by opening a
[Dataset request GitHub issue](https://github.com/tensorflow/datasets/issues/new?assignees=&labels=dataset+request&template=dataset-request.md&title=%5Bdata+request%5D+%3Cdataset+name%3E).

And vote on the current
[set of requests](https://github.com/tensorflow/datasets/labels/dataset%20request)
by adding a thumbs-up reaction to the issue.

#### *Disclaimers*

*This is a utility library that downloads and prepares public datasets. We do*
*not host or distribute these datasets, vouch for their quality or fairness, or*
*claim that you have license to use the dataset. It is your responsibility to*
*determine whether you have permission to use the dataset under the dataset's*
*license.*

*If you're a dataset owner and wish to update any part of it (description,*
*citation, etc.), or do not want your dataset to be included in this*
*library, please get in touch through a GitHub issue. Thanks for your*
*contribution to the ML community!*

*If you're interested in learning more about responsible AI practices, including*
*fairness, please see Google AI's [Responsible AI Practices](https://ai.google/education/responsible-ai-practices).*

*`tensorflow/datasets` is Apache 2.0 licensed. See the `LICENSE` file.*

This is the version 4.6 of a2ps, a program to format an ASCII file for
printing in a postscript printer. As the copyright indicates, this
distribution can be freely redistributed.

Initial version was a shell program written by evan@csli (Evan
Kirshenbaum). It was very slow and contained many bugs. A new version
was written in C by Miguel SANTANA for improve speed execution and
portability.  Many new features and improvements have been added since
this first version. Many contributions (changes, fixes, ideas) were
done by a2ps users in order to improve it. From the latest known
version from M. Santana (4.3), Emmanuel Briot implemented bold faces
for keywords in ada, c and c++. Starting from this point, remodeling
completely the style description and handling for the various
languages, E. Briot and A. Demaille built this version, fully
compatible with version 4.3.

Some notes on the distribution:

    Most of the work for the installation is done by ./configure.
    See INSTALL for instructions.
    Some choices are to make, and to give to ./configure
	--disable-A4
		if you want US letter as standard sheet
	--disable-ISOLatin1
		if you want only ASCII as default
        --disable_auto
		if you don't want a2ps to guess the style sheet to
		use by default. Its guess is based on file suffix.
		If disable, default is to print is plain style
	--enable-print-default
		if you want that default output is to printer
		instead of stdout
  	--enable-1sided=OPT
		OPT is the option to give the the print service
		to get single sided prints
  	--enable-2sided=OPT
		Same as previous, but for double sided prints. This option
		is required if you expect a2ps to have double-sided
		capabilities. Here, I use
		--enable-2sided=-odouble
	--disable-2-sided
		if you don't want that default behaviour is to print
		double-sided

    a2ps has been successfully ported to Solaris, SunOS, Linux, HP-UX.
    It is even used as a filter for print services.

    a2ps *had* been successfully MSDOS. 
    Now it's up to you to tell us whether it is still portable :)

The a2ps distribution consists of the following files:

	README		This message
	INSTALL		Information on the installation process
	TODO		Some things to be done
	configure	A shell script that helps the installation
	Makefile.in config.h.in configure.in
			Everything about configuring
	a2ps.h		global typedefs, vars, defines etc.
	a2ps.c		main routine and interface with user
	style.[ch]	style sheets for each languages
	styles.c.in	a precursor of styles.c
			This is the file you should work on if you
			want to specify new languages. Needs GNU m4.
	afm.[ch]	metric info on postscript fonts
	buffer.[ch]	input and parsing routines
	postscript.[ch]	routines for output in postscript
	report.[ch]	routines related to option -W
	a2ps.man	a troff manual (man file)

Please send problems and feedback to:

   Akim Demaille (demaille@inf.enst.fr)
   Emmanuel Briot (ebr@drce.matra-com.fr)

PS(um): if you're happy with a2ps, or just if you installed it, please
let_us_know! We would be so happy :).

## A simple span class for storing start and end integer offsets.

## Apache OpenNLP optionally allows storing types in spans: we use 
## Annotation objects (with no ids or features) for this.

## Conceptually, a single span is a start/end pair and our Span objects
## are sequences (to allow positional access) of spans, i.e., sequences
## of pairs.
## The implementation actually uses a "pair" (named list of length two)
## of "slots" giving the start and end value sequences.
## Subscripting via [ extracts subsets of spans.
## Subscripting via $ extracts one slot.

Span_slot_names <- c("start", "end")

Span <-
function(start, end)
{
    start <- as.integer(start)
    end <- as.integer(end)
    if(length(start) != length(end))
        stop("arguments must have the same length")
    .Span_from_args(start, end)
}

.Span_from_args <-
function(start, end)
    .Span_from_list(list(start = start, end = end))

.Span_from_list <-
function(x)
{
    class(x) <- "Span"
    x
}

as.Span <-
function(x)
    UseMethod("as.Span")

as.Span.Span <- identity

as.Span.Annotation <-
function(x)
    .Span_from_args(x$start, x$end)

is.Span <-
function(x)
    inherits(x, "Span")

`[.Span` <-
function(x, i)
    .Span_from_list(lapply(unclass(x), `[`, i))

## <TODO>
## Implement eventually ...
`[<-.Span` <-
function(x, i, value)
    .NotYetImplemented()
## </TODO>

`[[.Span` <-
function(x, i)
    .Span_from_list(lapply(unclass(x), `[[`, i))

## <TODO>
## Implement eventually ...
`[[<-.Span` <-
function(x, i, value)
    .NotYetImplemented()
## </TODO>

## $.Span is not really necessary.
`$<-.Span` <-
function(x, name, value)
{
    n <- length(x)
    x <- unclass(x)
    if(is.na(pos <- pmatch(name, Span_slot_names)))
        stop("invalid element name")
    value <- as.integer(value)
    if(length(value) != n)
        stop("replacement must have the same length as object")
    x[[pos]] <- value
    .Span_from_list(x)
}

Ops.Span <-
function(e1, e2)
{
    ## Allow to add offsets.
    switch(as.character(.Generic),
           "+" = {
               if(is.Span(e1) && is.numeric(e2) && (length(e2) == 1L))
                   return(Span(e1$start + e2, e1$end + e2))
               if(is.Span(e2) && is.numeric(e1) && (length(e1) == 1L))
                   return(Span(e2$start + e1, e2$end + e1))
               stop("Invalid operands.")
           },
           stop(gettextf("'%s' not defined for \"Span\" objects", 
                         .Generic),
                domain = NA))
}

as.data.frame.Span <-
function(x, row.names = NULL, optional = FALSE, ...)
{
    data.frame(start = x$start, end = x$end, row.names = row.names)
}

as.list.Span <-
function(x,  ...) 
    lapply(seq_along(x), function(i) x[i])

c.Span <-
function(..., recursive = FALSE)
{
    args <- lapply(list(...), function(e) unclass(as.Span(e)))
    y <- lapply(Span_slot_names,
                function(e) unlist(lapply(args, `[[`, e)))
    names(y) <- Span_slot_names
    .Span_from_list(y)
}

duplicated.Span <-
function(x, incomparables = FALSE, ...)
{
    do.call(`&`, lapply(unclass(x), duplicated))
}

format.Span <-
function(x, ...)
{
    format(as.data.frame(x), ...)
}

length.Span <-
function(x)
    length(x$start)

names.Span <-
function(x)
    NULL

print.Span <-
function(x, ...)
{
    print.data.frame(format(x), ..., row.names = FALSE)
    invisible(x)
}

unique.Span <-
function(x, incomparables = FALSE, ...)
    x[!duplicated(x)]

## Annotations.

## Conceptually, a single annotation is a quintuple with "slots" id,
## type, start, end and features, and our Annotation objects are
## sequences (to allow positional access) of annotations, i.e., sequence
## of such quintuples.
## The implementation actually uses a "quintuple" (named list of length
## five) with slots giving the respective sequences of slot values.
## The feature slot of a single annotation is a feature map which we
## represent as named lists (at least for now also allowing NULL for an
## empty feature map), hence the sequence of feature values is a list of
## named lists.
## Subscripting via [ extracts subsets of annotations.
## Subscripting via $ extracts one slot value sequence.
## As Annotation objects have all slots of Span objects, we take them to
## have class "Annotation" and also inherit from class "Span".
## We allow for ids to be missing, and Annotation(id = NULL) creates
## missing ids as needed.

Annotation_classes <- c("Annotation", "Span")
Annotation_slot_names <- c("id", "type", "start", "end", "features")

Annotation <-
function(id = NULL, type = NULL, start, end, features = NULL,
         meta = list())
{
    if(nargs() == 0L) {
        ## Could also provide default values (e.g., NULL) for all
        ## arguments ...
        return(.Annotation_from_args(integer(),
                                     character(),
                                     integer(),
                                     integer(),
                                     list(),
                                     meta))
    } 

    start <- as.integer(start)
    end <- as.integer(end)
    n <- length(start)
    id <- if(is.null(id))
        rep.int(NA_integer_, n)
    else
        as.integer(id)
    type <- if(is.null(type))
        rep.int(NA_character_, n)
    else
        as.character(type)
    features <- if(is.null(features))
        rep.int(list(list()), n)
    else
        lapply(features, as.list)
    ## <TODO>
    ## Should perhaps check that all elements of 'features' are named or
    ## empty lists.
    ## </TODO>

    .Annotation_from_args(id, type, start, end, features, meta)
}

.Annotation_from_args <-
function(id, type, start, end, features, meta)
{
    x <- list(id, type, start, end, features)
    if(any(diff(lengths(x)) != 0L))
        stop("arguments must have the same length")
    names(x) <- Annotation_slot_names
    .Annotation_from_list_and_meta(x, meta)
}
.Annotation_from_list_and_meta <-
function(x, meta)
{
    class(x) <- Annotation_classes
    attr(x, "meta") <- meta
    x
}

as.Annotation <-
function(x, ...)
    UseMethod("as.Annotation")

as.Annotation.Annotation <-
function(x, ...)
    x

as.Annotation.Span <-
function(x, id = NULL, type = NULL, ...)
{
    ## Call Annotation() so we get coercion and length checking.
    Annotation(id, type, x$start, x$end, NULL)
}

is.Annotation <-
function(x)
    inherits(x, "Annotation")

`[.Annotation` <-
function(x, i)
    .Annotation_from_list_and_meta(lapply(unclass(x), `[`, i),
                                   attr(x, "meta"))

## <TODO>
## Implement eventually ...
`[<-.Annotation` <-
function(x, i, value)
    .NotYetImplemented()
## </TODO>

`[[.Annotation` <-
function(x, i)
{
    y <- lapply(unclass(x), `[[`, i)
    y$features <- list(y$features)
    .Annotation_from_list_and_meta(y, attr(x, "meta"))
}

## <TODO>
## Implement eventually ...
`[[<-.Annotation` <-
function(x, i, value)
    .NotYetImplemented()
## </TODO>

## $.Annotation is not really necessary.

`$<-.Annotation` <-
function(x, name, value)
{
    n <- length(x)
    x <- unclass(x)
    if(is.na(pos <- pmatch(name, Annotation_slot_names)))
        stop("invalid element name")
    name <- Annotation_slot_names[pos]
    value <- if(name == "type")
        as.character(value)
    else if(name == "features")
        as.list(value)
    else
        as.integer(value)
    ## This is not very elegant: we could record the slot modes as
    ##   Annotation_slot_modes <-
    ##     c("integer", "character", "integer", "integer", "list")
    ## but then coercion via the respective as.MODE functions would need
    ## some trickery ... maybe do this at a later stage, and modify the
    ## Annotation() creator accordingly.
    if(length(value) != n)
        stop("replacement must have the same length as object")
    x[[pos]] <- value
    
    .Annotation_from_list_and_meta(x, attr(x, "meta"))
}

as.data.frame.Annotation <-
function(x, row.names = NULL, optional = FALSE, ...)
{
    y <- data.frame(id = x$id,
                    type = x$type,
                    start = x$start,
                    end = x$end,
                    stringsAsFactors = FALSE,
                    row.names = row.names)
    y$features <- x$features
    y
}

as.list.Annotation <-
function(x,  ...) 
    lapply(seq_along(x), function(i) x[i])

c.Annotation <-
function(..., recursive = FALSE)
{
    args <- lapply(list(...), as.Annotation)
    meta <- do.call(c, lapply(args, meta))
    args <- lapply(args, unclass)

    y <- lapply(Annotation_slot_names,
                function(e) unlist(lapply(args, `[[`, e),
                                   recursive = FALSE))
    names(y) <- Annotation_slot_names

    ## Remove *exact* duplicates from metadata:
    if(length(meta)) {
        meta <- tapply(meta, names(meta), unique, simplify = FALSE)
        tags <- rep.int(names(meta), lengths(meta))
        meta <- unlist(meta, recursive = FALSE, use.names = FALSE)
        names(meta) <- tags
    }
    
    .Annotation_from_list_and_meta(y, meta)
}

## This is at the mercy of duplicated() working well on lists ...
duplicated.Annotation <-
function(x, incomparables = FALSE, ...)
{
    Reduce(`&`, lapply(unclass(x), duplicated))
}

format.Annotation <-
function(x, values = TRUE, ...)
{
    if(!length(x)) return(character())
    y <- .format_Annotation_without_features(x)
    wy <- nchar(y[1L], type = "width")
    wf <- max(16L, 0.95 * getOption("width") - wy)
    collapse <- format("\n", width = wy + 2L)
    features <- lapply(x$features, function(e) {
        if(!(l <- length(e))) return("")
        s <- if(values) .format_feature_map(e) else names(e)
        s <- paste0(s, c(rep_len(",", l - 1L), ""))
        w <- nchar(strwrap(paste(gsub(".", "X", s), collapse = " "),
                           width = wf))
        v <- c(0L, head(cumsum(w + 1L), -1L))
        f <- v + 1L
        t <- v + w
        paste(substring(paste(s, collapse = " "), f, t),
              collapse = collapse)
    })
    paste0(y, c("features", features), collapse = "\n")
}

inspect.Annotation <-
function(x)
{
    x$features <-
        vapply(x$features,
               function(e) {
                   if(length(s <- .format_feature_map(e))) {
                       paste(sprintf("\n  %s", s), collapse = "")
                   } else NA_character_
               },
               "")
    write.dcf(x, keep.white = "features")
}

length.Annotation <-
function(x)
    length(x$start)

merge.Annotation <-
function(x, y, ...)
{
    pos <- match(paste(y$id, y$type, y$start, y$end, sep = "\r"),
                 paste(x$id, x$type, x$start, x$end, sep = "\r"),
                 nomatch = 0L)
    ## <NOTE>
    ## This should really combine the unique tag/value pairs.
    ## In fact, duplicated tags are a problem, but how should they be
    ## handled (take the pair from x or from y)?
    x$features[pos] <- Map(c, x$features[pos], y$features[pos > 0L])
    ## </NOTE>
    c(x, y[pos == 0L])
}

## meta.Annotation <-
## function(x, tag = NULL, ...)
## {
##     m <- attr(x, "meta")
##     if(is.null(tag)) m else m[[tag]]
## }

## `meta<-.Annotation` <-
## function(x, tag = NULL, ..., value)    
## {
##     if(is.null(tag))
##         attr(x, "meta") <- value
##     else
##         attr(x, "meta")[[tag]] <- value
##     x
## }

names.Annotation <-
function(x)
    NULL

## print.Annotation <-
## function(x, values = TRUE, ...)
## {
##     writeLines(format(x, values = values))
##     invisible(x)
## }

subset.Annotation <-
function(x, subset, ...)
{
    e <- substitute(subset)
    i <- eval(e, unclass(x), parent.frame())
    if(!is.logical(i)) 
        stop("'subset' must be logical")
    i <- i & !is.na(i)
    x[i]
}

unique.Annotation <-
function(x, incomparables = FALSE, ...)
    x[!duplicated(x)]
    
.format_Annotation_without_features <-
function(x)
{
    sprintf(" %s %s %s %s ",
            .format_values_with_header(x$id, "id", "right"),
            .format_values_with_header(x$type, "type", "left"),
            .format_values_with_header(x$start, "start", "right"),
            .format_values_with_header(x$end, "end", "right"))
}

.format_values_with_header <-
function(v, h, justify = c("left", "right"))
{
    justify <- match.arg(justify)
    width <- max(nchar(h), nchar(v))
    len <- length(v)
    fmt <- sprintf("%%%s%ds",
                   c("-", rep.int(if(justify == "left") "-" else "", len)),
                   rep.int(width, len + 1L))
    sprintf(fmt, c(h, v))
}

## Try formatting feature maps nicely.
## Similar to what we do in package 'sets', I guess ...
.format_feature_map <-
function(x, ...)
{
    if(!length(x))
        return(character())
    sprintf("%s=%s", names(x), vapply(x, .format_feature_value, ""))
}

## Formatter for a single value.
.format_feature_value <-
function(x)
{
    ## Could also make this a generic, which currently seems an
    ## overkill, in particular if it is not exported so that no one else
    ## can register methods.
    if(inherits(x, "Stanford_typed_dependencies"))
        sprintf("<<%s,%s>>", class(x)[1L], nrow(x))
    else if(is.object(x))
        sprintf("<<%s>>", class(x)[1L])
    else if(is.array(x))
        sprintf("<<array,%s>>", paste(dim(x), collapse = ","))
    else if(is.character(x) && (length(x) == 1L)) {
        if(nchar(x) <= 32L) x else "<<character,1>>"
    }
    else if(is.atomic(x) && (length(x) == 1L)) {
        ## <FIXME>
        ## Should this take ... args?
        ## Also, might want to ensure this does not get too long.
        format(x)
        ## </FIXME>
    }
    else if(is.vector(x))
        sprintf("<<%s,%s>>", typeof(x), length(x))
    else if(is.null(x))
        "NULL"
    else
        "<<???>>"
}
            
annotations_in_spans <-
function(x, y)
{
    y <- as.Span(y)
    
    ## An annotation node is contained in a span if it does not start
    ## ahead of the span and does not end later than the span.

    ind <- outer(x$start, y$start, `>=`) & outer(x$end, y$end, `<=`)

    lapply(seq_len(ncol(ind)), function(j) x[ind[, j]])
}

features <-
function(x, type = NULL, simplify = TRUE)
{
    if(inherits(x, "AnnotatedPlainTextDocument"))
        x <- x$annotation
    else if(!is.Annotation(x))
        stop("argument 'x' must be an Annotation object")
    if(!is.null(type)) {
        types <- unique(x$type)
        i <- pmatch(type, types)
        if(any(is.na(i)))
            stop("incomplete or invalid 'type'")
        x <- x[x$type %in% types[i]]
    }
    features <- x$features
    tags <- unique(unlist(lapply(features, names)))
    y <- lapply(tags, function(tag) lapply(features, `[[`, tag))
    if(simplify) y <- lapply(y, .simplify)
    names(y) <- tags
    class(y) <- "data.frame"
    attr(y, "row.names") <- .set_row_names(length(features))
    y
}

.simplify <-
function(x)
{
    if((length(len <- unique(lengths(x))) == 1L) && (len == 1L))
        unlist(x, recursive = FALSE)
    else
        x
}

## A simple class for storing tokens and tags ("tagged tokens").

## Conceptually, a single tagged token is a token/tag pair and our
## Tagged_Token objects are sequences (to allow positional access) of
## tagged tokens, i.e., sequences of pairs.
## The implementation actually uses a "pair" (named list of length two)
## of "slots" giving the token and tag sequences.
## Subscripting via [ extracts subsets of tagged tokens.
## Subscripting via $ extracts one slot.

Tagged_Token_slot_names <- c("token", "tag")

Tagged_Token <-
function(token, tag)
{
    token <- as.character(token)
    tag <- as.character(tag)
    if(length(token) != length(tag))
        stop("arguments must have the same length")
    .Tagged_Token_from_args(token, tag)
}

.Tagged_Token_from_args <-
function(token, tag)
{
    x <- list(token, tag)
    names(x) <- Tagged_Token_slot_names
    .Tagged_Token_from_list(x)
}

.Tagged_Token_from_list <-
function(x)
{
    class(x) <- "Tagged_Token"
    x
}

as.Tagged_Token <-
function(x)
    UseMethod("as.Tagged_Token")

as.Tagged_Token.Tagged_Token <- identity

## <FIXME>
## Should this get a '...'?  (And hence the generic, too?)
as.Tagged_Token.TextDocument <-
function(x)
    tagged_words(x)
## </FIXME>

is.Tagged_Token <-
function(x)
    inherits(x, "Tagged_Token")

`[.Tagged_Token` <-
function(x, i)
    .Tagged_Token_from_list(lapply(unclass(x), `[`, i))

## <TODO>
## Implement eventually ...
`[<-.Tagged_Token` <-
function(x, i, value)
    .NotYetImplemented()
## </TODO>

`[[.Tagged_Token` <-
function(x, i)
    .Tagged_Token_from_list(lapply(unclass(x), `[[`, i))

## <TODO>
## Implement eventually ...
`[[<-.Tagged_Token` <-
function(x, i, value)
    .NotYetImplemented()
## </TODO>

## $.Tagged_Token is not really necessary.
`$<-.Tagged_Token` <-
function(x, name, value)
{
    n <- length(x)
    x <- unclass(x)
    if(is.na(pos <- pmatch(name, Tagged_Token_slot_names)))
        stop("invalid element name")
    value <- as.integer(value)
    if(length(value) != n)
        stop("replacement must have the same length as object")
    x[[pos]] <- value
    .Tagged_Token_from_list(x)
}

as.data.frame.Tagged_Token <-
function(x, row.names = NULL, optional = FALSE, ...)
{
    data.frame(token = x$token, tag = x$tag, row.names = row.names)
}

as.list.Tagged_Token <-
function(x,  ...) 
    lapply(seq_along(x), function(i) x[i])

c.Tagged_Token <-
function(..., recursive = FALSE)
{
    args <- lapply(list(...), function(e) unclass(as.Tagged_Token(e)))
    y <- lapply(Tagged_Token_slot_names,
                function(e) unlist(lapply(args, `[[`, e)))
    names(y) <- Tagged_Token_slot_names
    .Tagged_Token_from_list(y)
}

duplicated.Tagged_Token <-
function(x, incomparables = FALSE, ...)
{
    do.call(`&`, lapply(unclass(x), duplicated))
}

format.Tagged_Token <-
function(x, ...)
{
    sprintf("%s/%s", x$token, x$tag)
}

length.Tagged_Token <-
function(x)
    length(x$token)

names.Tagged_Token <-
function(x)
    NULL

## print.Tagged_Token <-
## function(x, ...)
## {
##     print(format(x, ...))
##     invisible(x)
## }

unique.Tagged_Token <-
function(x, incomparables = FALSE, ...)
    x[!duplicated(x)]

CoNLLTextDocument <-
function(con, encoding = "unknown", format = "conll00", meta = list())
{
    if(length(format) == 1L) {
        format <-
            switch(format,
                   conll00 = c(WORD = "WORD",
                               POS = "POS",
                               CHUNK = "CHUNK"),
                   conll01 = c(WORD = "WORD",
                               POS = "POS",
                               CHUNK = "CHUNK",
                               "CLAUSE"),
                   conll02 = c(WORD = "WORD",
                               NE = "NE"),
                   ## conll03 would have different fields for the German
                   ## variant
                   conllx  = c("ID",
                               WORD = "FORM",
                               "LEMMA",
                               POS = "CPOSTAG",
                               "POSTAG", "FEATS", "HEAD", 
                               "DEPREL", "PHEAD", "PDEPREL"),
                   ## Corresponding to CoNLL X (10) from 2006, also used
                   ## for conll07
                   conll09 = c("ID",
                               WORD = "FORM",
                               "LEMMA", "PLEMMA",
                               POS = "POS",
                               "PPOS", "FEAT", "PFEAT", "HEAD", "PHEAD",
                               "DEPREL", "PDEPREL", "FILLPRED", "PRED",
                               "APREDs"))
    }

    records <- scan(con, what = rep.int(list(""), length(format)),
                    encoding = encoding, quote = NULL, quiet = TRUE,
                    fill = TRUE, blank.lines.skip = FALSE)
    names(records) <- format
    ind <- (records[[1L]] == "")
    tab <- cbind(data.frame(sent = cumsum(ind) + 1L),
                 as.data.frame(do.call(cbind, records),
                               stringsAsFactors = FALSE))[!ind, ]
    attr(tab, "format") <- c("sent", format)

    doc <- list(content = tab,
                meta = meta)
    class(doc) <- c("CoNLLTextDocument", "TextDocument")
    doc
}

format.CoNLLTextDocument <-
function(x, ...)
{
    content <- x$content
    nr <- NROW(content)
    c(.format_TextDocument(x),
      sprintf("Content:  words: %d, sents: %d",
              nr,
              content[[nr, "sent"]]))
}

## print.CoNLLTextDocument <-
## function(x, ...)
## {
##     content <- x$content
##     nr <- NROW(content)
##     writeLines(sprintf("<<CoNLLTextDocument (words: %d, sents: %d)>>",
##                        nr, content[[nr, "sent"]]))
##     invisible(x)
## }

content.CoNLLTextDocument <-
function(x)
    x$content

## meta.CoNLLTextDocument <-
## function(x, tag = NULL, ...)
##     if(is.null(tag)) x$meta else x$meta[[tag]]

## `meta<-.CoNLLTextDocument` <-
## function(x, tag = NULL, ..., value)
## {
##     if(is.null(tag))
##         x$meta <- value
##     else
##         x$meta[[tag]] <- value
##     x
## }

as.character.CoNLLTextDocument <-
words.CoNLLTextDocument <-
function(x, ...)
{
    fmt <- attr(x$content, "format")
    pos <- .position_of_field(fmt, "WORD")
    x$content[[pos]]
}

sents.CoNLLTextDocument <-
function(x, ...)
{
    fmt <- attr(x$content, "format")
    pos <- .position_of_field(fmt, "WORD")
    split(x$content[[pos]],
          x$content$sent)
}

tagged_words.CoNLLTextDocument <-
function(x, map = NULL, ...)
{
    if(!is.null(map))
        x <- .map_POS_tags_CoNLLTextDocument(x, map)
    fmt <- attr(x$content, "format")
    pos_W <- .position_of_field(fmt, "WORD")
    pos_P <- .position_of_field(fmt, "POS")
    Tagged_Token(x$content[[pos_W]], x$content[[pos_P]])
}

tagged_sents.CoNLLTextDocument <-
function(x, map = NULL, ...)
{
    if(!is.null(map))
        x <- .map_POS_tags_CoNLLTextDocument(x, map)
    fmt <- attr(x$content, "format")
    pos_W <- .position_of_field(fmt, "WORD")
    pos_P <- .position_of_field(fmt, "POS")
    split(Tagged_Token(x$content[[pos_W]], x$content[[pos_P]]),
          x$content$sent)
}

chunked_sents.CoNLLTextDocument <-
function(x, ...)
{
    fmt <- attr(x$content, "format")
    pos_W <- .position_of_field(fmt, "WORD")
    pos_P <- .position_of_field(fmt, "POS")
    pos_C <- .position_of_field(fmt, "CHUNK")
    Map(chunk_tree_from_chunk_info,
        split(x$content[[pos_W]], x$content$sent),
        split(x$content[[pos_P]], x$content$sent),
        split(x$content[[pos_C]], x$content$sent))
}

.map_POS_tags_CoNLLTextDocument <-
function(x, map)
{
    map <- POS_tag_mapper(map, meta(x, "POS_tagset"))
    fmt <- attr(x$content, "format")
    pos <- .position_of_field(fmt, "POS")    
    x$content[[pos]] <- map(x$content[[pos]])
    x
}

.position_of_field <-
function(fmt, kind)
{
    pos <- which(names(fmt) == kind)
    if(length(pos) != 1L)
        stop(gettextf("Cannot determine position of '%s'", kind),
             call. = FALSE, domain = NA)
    pos
}

Tree <-
function(value, children = list())
{
    y <- list(value = value, children = as.list(children))
    class(y) <- "Tree"
    y
}

format.Tree <-
function(x,
         width = 0.9 * getOption("width"), indent = 0,
         brackets = c("(", ")"), ...)
{
    ffmt <- function(x) {
        sprintf("%s%s %s%s",
                brackets[1L],
                x$value,
                paste(sapply(x$children,
                             function(e) {
                                 if(inherits(e, "Tree"))
                                     ffmt(e)
                                 else
                                     format(e)
                             }),
                      collapse = " "),
                brackets[2L])
    }

    s <- ffmt(x)
    if(nchar(s) + indent < width) return(s)

    y <- sapply(x$children,
                function(e) {
                    if(inherits(e, "Tree"))
                        format(e, width = width, indent = indent + 2L,
                               brackets = brackets)
                    else
                        format(e)
                })
    y <- sprintf("\n%s%s",
                 paste(rep.int(" ", indent + 2L), collapse = ""),
                 y)
    sprintf("%s%s%s%s",
            brackets[1L],
            x$value,
            paste(y, collapse = ""),
            brackets[2L])
}

## print.Tree <-
## function(x, ...)
## {
##     writeLines(format(x, ...))
##     invisible(x)
## }
    
Tree_parse <-
function(x, brackets = c("(", ")"))
{
    errfmt <- function(token, expected) {
        sprintf("expected %s but got %s", expected, token)
    }

    re_o <- sprintf("\\%s", brackets[1L]) # open
    re_c <- sprintf("\\%s", brackets[2L]) # close
    re_n <- sprintf("[^\\s%s%s]+", re_o, re_c) # node
    re_l <- sprintf("[^\\s%s%s]+", re_o, re_c) # leaf
    re <- sprintf("%s\\s*(%s)?|%s|(%s)", re_o, re_n, re_c, re_l)
    m <- gregexpr(re, x, perl = TRUE)

    stack <- list(list(NULL, list()))

    for(token in regmatches(x, m)[[1L]]) {
        if(substring(token, 1L, 1L) == "(") {
            if((length(stack) == 1L) &&
               (length(stack[[1L]][[2L]]) > 0L))
                stop(errfmt(sQuote(token), "end of string"))
            value <- sub("\\s*", "", substring(token, 2L))
            stack <- c(stack, list(Tree(value, list())))
        }
        else if(token == ")") {
            if((n <- length(stack)) == 1L) {
                if(!length(stack[[1L]][[2L]]))
                    stop(errfmt(sQuote(token), sQuote(brackets[1L])))
                else
                    stop(errfmt(sQuote(token), "end of string"))
            }
            elt <- stack[[n]]
            ## class(elt) <- "Tree"
            stack <- stack[-n]
            n <- n - 1L
            stack[[n]][[2L]] <- c(stack[[n]][[2L]], list(elt))
        }
        else {
            if((n <- length(stack)) == 1L)
                stop(errfmt(sQuote(token), sQuote(brackets[1L])))
            stack[[n]][[2L]] <- c(stack[[n]][[2L]], list(token))
        }
    }

    if(length(stack) > 1L)
        stop(errfmt("end of string", sQuote(brackets[2L])))
    else if(!length(stack[[1L]][[2L]]))
        stop(errfmt("end of string", sQuote(brackets[1L])))

    stack[[1L]][[2L]][[1L]]
}

Tree_apply <-
function(x, f, recursive = FALSE)
{
    if(!recursive) return(lapply(x$children, f))

    g <- function(e) {
        y <- f(e)
        if(inherits(e, "Tree"))
            list(y, lapply(e$children, g))
        else
            y
    }

    lapply(x$children, g)
}

ISO_8601_datetime_components <-
    c("year", "mon", "day", "hour", "min", "sec", "tzd")

parse_ISO_8601_datetime <-
function(x)
{
    x <- as.character(x)
    n <- length(x)
    y <- matrix("", n, 7L)
    dimnames(y) <- list(x, ISO_8601_datetime_components)

    pos <- seq_along(x)

    bad <- (is.na(x) |
            (x == "") |
            ((nzchar(x) > 10L) & (substring(x, 11L, 11L) != "T")))
    if(any(bad)) {
        pos <- pos[!bad]
        x <- x[pos]
    }

    dates <- substring(x, 1L, 10L)
    pat <- "^([[:digit:]]{4})(-[[:digit:]]{2})?(-[[:digit:]]{2})?$"
    m <- regmatches(dates, regexec(pat, dates))
    ind <- lengths(m) > 0L
    if(!all(ind)) {
        bad[pos[!ind]] <- TRUE
        pos <- pos[ind]
        x <- x[ind]
        m <- m[ind]
    }
    y[pos, 1L : 3L] <-
        do.call(rbind, m)[, 2L : 4L]

    ind <- (nchar(x) > 10L)
    if(any(ind)) {
        if(!all(ind)) {
            pos <- pos[ind]
            x <- x[ind]
        }
        times <- substring(x, 12L)
        pat <- paste("^",
                     "([[:digit:]]{2}):([[:digit:]]{2})",
                     "(:[[:digit:]]{2}([.][[:digit:]]+)?)?",
                     "(Z|[+-][[:digit:]]{2}:[[:digit:]]{2})",
                     "$",
                     sep = "")
        m <- regmatches(times, regexec(pat, times))
        ind <- lengths(m) > 0L
        if(!all(ind))
            bad[pos[!ind]] <- TRUE
        y[pos[ind], 4L : 7L] <-
            do.call(rbind, m[ind])[, c(2L, 3L, 4L, 6L)]
    }

    y[, c(2L, 3L, 6L)] <- substring(y[, c(2L, 3L, 6L)], 2L)

    ## Warn about the bad entries.
    if(any(bad)) {
        warning("Invalid entries:",
                paste("\n ", rownames(y)[bad], collapse = " "))
        y[bad, ] <- ""
    }

    ## If we want year to sec as numeric and tzd as character, we need
    ## to do
    ##   y <- as.data.frame(y, stringsAsFactors = FALSE)
    ## and convert variables 1 to 6: note that this would turn empty to
    ## missing ...

    x <- rownames(y)
    w <- which(y != "", arr.ind = TRUE)
    y <- as.data.frame(y, stringsAsFactors = FALSE)
    y[, 1L : 5L] <- lapply(y[, 1L : 5L], as.integer)
    y[[6L]] <- as.numeric(y[[6L]])
    y <- Map(function(u, v) as.list(u[v]),
             split(y, seq_len(n)),
             split(w[, 2L], factor(w[, 1L], seq_len(n))))
    names(y) <- x
    class(y) <- "ISO_8601_datetime"
    y
}

`[.ISO_8601_datetime` <-
function(x, i)
{
    y <- unclass(x)[i]
    class(y) <- class(x)
    y
}

`$.ISO_8601_datetime` <-
function(x, name)
{
    name <- pmatch(name, ISO_8601_datetime_components)
    as.data.frame(x)[[name]]
}

as.matrix.ISO_8601_datetime <-
function(x, ...)
{
    y <- matrix("", length(x), 7L,
                dimnames = list(names(x), ISO_8601_datetime_components))
    nms <- lapply(x, names)
    y[cbind(rep.int(seq_along(x), lengths(nms)),
            match(unlist(nms), ISO_8601_datetime_components))] <-
                as.character(unlist(x))
    y
}

as.data.frame.ISO_8601_datetime <-
function(x, row.names = NULL, optional = FALSE, ...)
{
    y <- as.matrix(x)
    y[y == ""] <- NA_character_
    y <- as.data.frame(y, stringsAsFactors = FALSE)
    y[, 1L : 5L] <- lapply(y[, 1L : 5L], as.integer)
    y[[6L]] <- as.numeric(y[[6L]])
    y
}

as.Date.ISO_8601_datetime <-
function(x, ...)
{
    y <- as.matrix(x)
    y[y == ""] <- NA_character_
    as.Date(sprintf("%s-%s-%s", y[, 1L], y[, 2L], y[, 3L]),
            "%Y-%m-%d")
}

as.POSIXct.ISO_8601_datetime <-
function(x, tz = "", ...)
    as.POSIXct(as.POSIXlt(x))

as.POSIXlt.ISO_8601_datetime <-
function(x, tz = "", ...)
{
    y <- as.matrix(x)
    y[y == ""] <- NA_character_
    offsets <- sub(":", "", y[, 7L])
    offsets[offsets == "Z"] <- "+0000"
    y[, 7L] <- offsets
    strptime(do.call(paste, split(y, col(y))),
             "%Y %m %d %H %M %OS %z",
             tz = "UTC")
}

print.ISO_8601_datetime <-
function(x, ...)
{
    y <- as.matrix(x)
    y <- as.data.frame(y, stringsAsFactors = FALSE)
    print(y)
    invisible(x)
}

WordListDocument <-
function(con, encoding = "unknown", meta = list())
{
    words <- readLines(con, encoding = encoding, warn = FALSE)
    doc <- list(content = words, meta = meta)
    class(doc) <- c("WordListDocument", "TextDocument")
    doc
}

format.WordListDocument <-
function(x, ...)    
    c(.format_TextDocument(x),
      sprintf("Content:  words: %d", length(x$content)))
    
## print.WordListDocument <-
## function(x, ...)
## {
##     writeLines(sprintf("<<WordListDocument (words: %d)>>",
##                        length(x$content)))
##     invisible(x)
## }

content.WordListDocument <-
function(x)
    x$content

## meta.WordListDocument <-
## function(x, tag = NULL, ...)
##     if(is.null(tag)) x$meta else x$meta[[tag]]

## `meta<-.WordListDocument` <-
## function(x, tag = NULL, ..., value)
## {
##     if(is.null(tag))
##         x$meta <- value
##     else
##         x$meta[[tag]] <- value
##     x
## }

as.character.WordListDocument <-
words.WordListDocument <-
function(x, ...)
    x$content

TaggedTextDocument <-
function(con, encoding = "unknown",
         word_tokenizer = whitespace_tokenizer,
         sent_tokenizer = Regexp_Tokenizer("\n", invert = TRUE),
         para_tokenizer = blankline_tokenizer,
         sep = "/",
         meta = list())
{
    s <- String(paste(readLines(con, encoding = encoding, warn = FALSE),
                      collapse = "\n"))
    paras <- if(!is.null(para_tokenizer))
        s[para_tokenizer(s)]
    else
        as.character(s)

    x <- lapply(paras,
                function(para) {
                    ## Avoid as.String() coercion.
                    spans <- sent_tokenizer(para)
                    sents <- substring(para, spans$start, spans$end)
                    lapply(sents,
                           function(sent) {
                               spans <- word_tokenizer(sent)
                               words <-
                                   substring(sent, spans$start, spans$end)
                               toks <- strsplit(words, sep, fixed = TRUE)
                               one <- vapply(toks, `[[`, "", 1L)
                               two <- vapply(toks, `[[`, "", 2L)
                               data.frame(word = one, 
                                          POS = toupper(two),
                                          stringsAsFactors = FALSE)
                           })
                })

    ## Use sentence ids which are unique across paras.

    lens <- lapply(x, length)
    ids <- Map(function(f, l)
               as.integer(seq.int(from = f, length.out = l)),
               c(0L, head(cumsum(lens), -1L)) + 1L,
               lens)

    x <- Map(function(u, v) {
        cbind(data.frame(sent = rep.int(u, vapply(v, nrow, 0L))),
              do.call(rbind, v))
    },
        ids, x)

    doc <- list(content = x, meta = meta)
    class(doc) <- c("TaggedTextDocument", "TextDocument")

    doc
}

format.TaggedTextDocument <-
function(x, ...)
{
    content <- x$content
    len <- length(content)
    c(.format_TextDocument(x),
      sprintf("Content:  words: %d, sents: %d, paras: %d",
              sum(vapply(content, NROW, 0L)),
              tail(content[[len]]$sent, 1L),
              len))
}

## print.TaggedTextDocument <-
## function(x, ...)
## {
##     content <- x$content
##     len <- length(content)
##     writeLines(sprintf("<<TaggedTextDocument (words: %d, sents: %d, paras: %d)>>",
##                        sum(vapply(content, NROW, 0L)),
##                        tail(content[[len]]$sent, 1L),
##                        len))
##     invisible(x)
## }

content.TaggedTextDocument <-
function(x)
    x$content

## meta.TaggedTextDocument <-
## function(x, tag = NULL, ...)
##     if(is.null(tag)) x$meta else x$meta[[tag]]

## `meta<-.TaggedTextDocument` <-
## function(x, tag = NULL, ..., value)
## {
##     if(is.null(tag))
##         x$meta <- value
##     else
##         x$meta[[tag]] <- value
##     x
## }

## <NOTE>
## It would be nice if the as.character() method could "suitably"
## detokenize the word tokens into sentences.  But this requires
## (a) knowing at least the language of the text
## (b) having code to detokenize when knowing the language ...
## </NOTE>

as.character.TaggedTextDocument <-
words.TaggedTextDocument <-
function(x, ...)
{
    unlist(lapply(x$content, `[[`, "word"))
}

## <NOTE>
## Could more simply do
##   sents.TaggedTextDocument <- function(x, ...)
##       unlist(paras(x), recursive = FALSE)
## </NOTE>

sents.TaggedTextDocument <-
function(x, ...)
{
    unlist(lapply(x$content,
                  function(e) split(e$word, e$sent)),
           recursive = FALSE)
}

paras.TaggedTextDocument <-
function(x, ...)
{
    lapply(x$content,
           function(e) split(e$word, e$sent))
}

tagged_words.TaggedTextDocument <-
function(x, map = NULL, ...)
{
    if(!is.null(map)) {
        x <- .map_POS_tags_TaggedTextDocument(x, map)
    }
    Tagged_Token(unlist(lapply(x$content, `[[`, "word")),
                 unlist(lapply(x$content, `[[`, "POS")))
}

## <NOTE>
## Could more simply do
##   tagged_sents.TaggedTextDocument <- function(x, ...)
##       unlist(tagged_paras(x), recursive = FALSE)
## </NOTE>

tagged_sents.TaggedTextDocument <-
function(x, map = NULL, ...)
{
    if(!is.null(map)) {
        x <- .map_POS_tags_TaggedTextDocument(x, map)
    }
    unlist(lapply(x$content,
                  function(e)
                  split(Tagged_Token(e$word, e$POS), e$sent)),
           recursive = FALSE)
}
    
tagged_paras.TaggedTextDocument <-
function(x, map = NULL, ...)
{
    if(!is.null(map)) {
        x <- .map_POS_tags_TaggedTextDocument(x, map)
    }
    lapply(x$content,
           function(e)
           split(Tagged_Token(e$word, e$POS), e$sent))
}

.map_POS_tags_TaggedTextDocument <-
function(x, map)
{
    map <- POS_tag_mapper(map, meta(x, "POS_tagset"))
    x$content <-
        lapply(x$content,
               function(e) {
                   e$POS <- map(e$POS)
                   e
               })
    x
}

parse_IETF_language_tag <-
function(x, expand = FALSE, strict = TRUE)
{
    n <- length(x)
    y <- rep.int(list(character()), n)
    names(y) <- x
    
    pos <- seq_along(x)    

    ## How nice should we be?
    ## Allow for empty or missing elements ...
    ind <- which(!is.na(x) & nzchar(x))
    pos <- pos[ind]
    x <- x[ind]

    ## See <https://www.ietf.org/rfc/rfc4646.txt>.
    ## Language tags can be of the form (in ABNF, see
    ## <https://tools.ietf.org/rfc/rfc4234.txt>): 
    ##   langtag / privateuse / grandfathered
    ## where
    ##   privateuse    = ("x"/"X") 1*("-" (1*8alphanum))
    ##   grandfathered = 1*3ALPHA 1*2("-" (2*8alphanum))

    re_privateuse <- "[xX]((-[[:alnum:]]{1,8}){1,})"

    ## Grandfathered tags must really be determined by exact matching.

    ind <- !is.na(match(x,
                        IANA_language_subtag_registry_grandfathered_table$Tag))
    if(any(ind)) {
        y[pos[ind]] <- as.list(sprintf("Grandfathered=%s", x[ind]))
        ind <- which(!ind)
        pos <- pos[ind]
        x <- x[ind]
    }

    if(length(pos)) {    
        pat <- sprintf("^%s$", re_privateuse)
        ind <- grepl(pat, x, perl = TRUE)
        if(any(ind)) {
            y[pos[ind]] <-
                as.list(sprintf("Privateuse=%s",
                                substring(x[ind], 3L)))
            ind <- which(!ind)
            pos <- pos[ind]
            x <- x[ind]
        }
    }

    ## Now for the real thing.

    ## Remaining tags should now be as follows:
    ##   (language
    ##    ["-" script]
    ##    ["-" region]
    ##    *(["-" variant])
    ##    *(["-" extension])
    ##    ["-" privateuse]
    ## where
    ##   language    = (2*3ALPHA [-extlang])  ; shortest ISO 639 code
    ##                  / 4ALPHA              ; reserved for future use
    ##                  / 5*8ALPHA            ; registered language subtag
    ##   extlang     = *3("-" 3*ALPHA)        ; reserved for future use
    ##   script      = 4ALPHA                 ; ISO 15924 code
    ##   region      = 2ALPHA                 ; ISO 3166 code
    ##                 / 3DIGIT               ; UN M.49 code
    ##   variant     = 5*8alphanum            ; registered variants
    ##                 / (DIGIT 3alphanum)
    ##   extension   = singleton 1*("-" (2*8alphanum))
    ##   singleton   = %x41-57 / %x59-5A / %x61-77 / %x79-7A / DIGIT
    ##               ; "a"-"w" / "y"-"z" / "A"-"W" / "Y"-"Z" / "0"-"9"

    ## We handle language/extlang a bit differently (more generously).

    re_extlang <- "[[:alpha:]]{3}"
    re_language <-
        sprintf("[[:alpha:]]{2,3}(-%s){0,3}|[[:alpha:]]{4,8}", re_extlang)
    re_script <- "[[:alpha:]]{4}"
    re_region <- "[[:alpha:]]{2}|[[:digit:]]{3}"
    re_variant <- "[[:alnum:]]{5,8}|[[:digit:]][[:alnum:]]{3}"
    re_singleton <- "[abcdefghijklmnopqrstuvwyzABCDEFGHIJKLMNOPQRSTUVWYZ0123456789]"
    re_extension <- sprintf("(%s)(-[[:alnum:]]{2,8}){1,}", re_singleton)

    bad <- integer()

    if(length(pos)) {
        pat <- sprintf("^(%s)(-.*|$)", re_language)
        ind <- grepl(pat, x, perl = TRUE)
        bad <- pos[!ind]
        pos <- pos[ind]
        x <- x[ind]
        y[pos] <-
            lapply(strsplit(sub(pat, "\\1", x, perl = TRUE),
                            "-", fixed = TRUE),
                   function(e) {
                       c(sprintf("Language=%s", e[1L]),
                         sprintf("Extension=%s", e[-1L]))
                   })
        x <- sub(pat, "\\3", x, perl = TRUE)
        ind <- which(nzchar(x))
        pos <- pos[ind]
        x <- x[ind]
    }

    if(length(pos)) {
        repeat {
            ## Use a loop so that we can finally stop when done.

            ## Script.
            pat <- sprintf("^-(%s)(-.*|$)", re_script)
            if(any(ind <- grepl(pat, x, perl = TRUE))) {
                y[pos[ind]] <-
                    Map(c,
                        y[pos[ind]],
                        sprintf("Script=%s",
                                sub(pat, "\\1", x[ind], perl = TRUE)))
                x[ind] <- sub(pat, "\\2", x[ind], perl = TRUE)
                ind <- which(nzchar(x))
                pos <- pos[ind]
                x <- x[ind]
                if(!length(x)) break
            }
        
            ## Region.
            pat <- sprintf("^-(%s)(-.*|$)", re_region)
            if(any(ind <- grepl(pat, x, perl = TRUE))) {
                y[pos[ind]] <-
                    Map(c,
                        y[pos[ind]],
                        sprintf("Region=%s",
                                sub(pat, "\\1", x[ind], perl = TRUE)))
                x[ind] <- sub(pat, "\\2", x[ind], perl = TRUE)
                ind <- which(nzchar(x))
                pos <- pos[ind]
                x <- x[ind]
                if(!length(x)) break
            }
        
            ## Variant(s).
            pat <- sprintf("^-(%s)(-.*|$)", re_variant)
            while(any(ind <- grepl(pat, x, perl = TRUE))) {
                y[pos[ind]] <-
                    Map(c,
                        y[pos[ind]],
                        sprintf("Variant=%s",
                                sub(pat, "\\1", x[ind], perl = TRUE)))
                x[ind] <- sub(pat, "\\2", x[ind], perl = TRUE)
                ind <- which(nzchar(x))
                pos <- pos[ind]
                x <- x[ind]
            }
            if(!length(x)) break

            ## Extension(s).
            pat <- sprintf("^-%s(-.*|$)", re_extension)
            while(any(ind <- grepl(pat, x, perl = TRUE))) {
                ## <NOTE>
                ## We keep the singleton prefix: this could be used in
                ## expansions of registered extensions: currently,
                ##   BCP 47 Extension U <https://tools.ietf.org/html/rfc6067>
                ##   BCP 47 Extension T <https://tools.ietf.org/html/rfc6497>
                y[pos[ind]] <-
                    Map(c,
                        y[pos[ind]],
                        sprintf("Extension=%s",
                                sub(pat, "\\1\\2", x[ind], perl = TRUE)))
                ## </NOTE>
                x[ind] <- sub(pat, "\\3", x[ind], perl = TRUE)
                ind <- which(nzchar(x))
                pos <- pos[ind]
                x <- x[ind]
            }
            if(!length(x)) break

            ## Private use.
            pat <- sprintf("^-%s(-.*|$)", re_privateuse)
            if(any(ind <- grepl(pat, x, perl = TRUE))) {
                y[pos[ind]] <-
                    Map(c,
                        y[pos[ind]],
                        sprintf("Privateuse=%s",
                                substring(sub(pat, "\\1", x[ind],
                                              perl = TRUE),
                                          2L)))
                x[ind] <- sub(pat, "\\4", x[ind], perl = TRUE)
            }

            break
        }
    }

    ## Be a nuisance: singletons for extensions must not be duplicated.
    ind <- vapply(y,
                  function(e) {
                      e <- grep("^Extension=", e, value = TRUE)
                      if(!length(e)) return(FALSE)
                      any(duplicated(sub("^Extension=(.).*", "\\1", e)))
                  },
                  NA)
    if(any(ind))
        bad <- c(bad, which(ind))
    if(any(ind <- nzchar(x))) {
        bad <- c(bad, pos[ind])
    }
    
    if(length(bad) && strict) {
        stop("Invalid language tag(s):",
             paste("\n ", sQuote(names(y)[bad]), collapse = " "),
             call. = FALSE)
    }

    if(!expand) return(y)

    n <- lengths(y)
    i <- (n > 0L)
    x <- tolower(unlist(y, use.names = FALSE))
    p <- match(x, IANA_language_subtag_registry$Index)
    z <- IANA_language_subtag_registry$Description[p]
    ## Special case private use ranges.
    if(!all(lengths(z))) {
        p <- match(x, IANA_language_subtag_registry_private_use_index_table)
        z[p > 0L | grepl("^privateuse=", x)] <- "Private use"
    }
    z <- Map(`names<-`, split(z, rep.int(seq_along(y), n)), y[i])
    y[i] <- z
    y
}

get_IANA_language_subtag_registry <-
function(con = "https://www.iana.org/assignments/language-subtag-registry")
{
    ## This is a collection of records in tag-value format, but
    ## unfortunately separated by '%%' lines rather than empty lines, so
    ## we cannot use read.dcf() directly.  Let us keep things simple:
    ## extract the records, write them out as DCF, and call read.dcf().

    lines <- readLines(con)
    ## The first line is something like
    ##   File-Date: 2009-03-13
    ## which we drop for reading the records.
    fdate <- sub(".*: *", "", lines[1L])
    pos <- grep("^%%", lines)
    lines[c(seq_len(pos[1L]), pos[-1L])] <- ""
    tcon <- textConnection(lines, encoding = "UTF-8")
    on.exit(close(tcon))
    db <- read.dcf(tcon, all = TRUE)
    ## Add index for lookups.
    subtag <- db$Subtag
    db$Index <-
        tolower(sprintf("%s=%s",
                        db$Type,
                        ifelse(is.na(subtag), db$Tag, subtag)))
    db$Type <- factor(db$Type)
    attr(db, "File_Date") <- fdate
    db
}

IANA_language_subtag_registry_language_private_use_subtags <-
    outer(letters[1L : 20L], letters,
          function(u, v) sprintf("q%s%s", u, v))
IANA_language_subtag_registry_script_private_use_subtags <-
    outer(c("a", "b"), letters[1L : 24L],
          function(u, v) sprintf("Qa%s%s", u, v))
IANA_language_subtag_registry_region_private_use_subtags <-
    c(sprintf("Q%s", LETTERS[13L : 26L]),
      sprintf("X%s", LETTERS))

IANA_language_subtag_registry_private_use_index_table <-
    tolower(c(sprintf("Language=%s",
                      IANA_language_subtag_registry_language_private_use_subtags),
              sprintf("Script=%s",
                      IANA_language_subtag_registry_script_private_use_subtags),
              sprintf("Region=%s",
                      IANA_language_subtag_registry_region_private_use_subtags)))

## A simple string class.

String <-
function(x)
{
    .String_from_string(as.character(x)[[1L]])
}

## Note subscripting by [[: this insists on the first element, and
## hence gives an error instead of NA_character_ if there is none.

as.String <-
function(x)
    UseMethod("as.String")

as.String.String <- identity

as.String.default <-
function(x)
    String(paste(x, collapse = "\n"))

is.String <-
function(x)
    inherits(x, "String")

print.String <-
function(x, ...)
    writeLines(x)

## Provide a '[' method performing slicing (as we cannot provide S3
## methods for substr, and clearly substrings of strings should be
## strings.

## Note that we have no distinction between spans and span arrays (same
## issue as having no distinction between strings and string arrays in
## base R).  Hence, we take spans to always operate in an array context
## (for now: we could add a drop = FALSE argument to have subscripting
## turn character vectors of length one back to strings again).

`[.String` <-
function(x, i, j)
{
    mysubstring <- function(x, i, j) {
        ## substring() recycles to max length of args only when this is
        ## positive.
        if(!length(i))
            character()
        else
            substring(x, i, j)
    }

    if(missing(j)) {
        if(is.Span(i))
            return(mysubstring(x, i$start, i$end))
        if(is.list(i)) {
            if(!length(i))
                return(list())
            else if(all(vapply(i, is.Span, NA))) 
                return(lapply(i,
                              function(e)
                                  mysubstring(x, e$start, e$end)))
        }
    }
    ## Regular slicing operators in a scalar context.
    String(substr(x, i, j))
}

## More methods?
##
## A popular mailing list discussion item is to use a Java style '+'
## operator for concatenating strings (not uniformly liked as the
## corresponding operation is not commutative):

`+.String` <-
function(e1, e2)
    .String_from_string(paste0(as.String(e1), as.String(e2)))

## Also provide Python-style string repetition.

`*.String` <-
function(e1, e2)
{
    if(is.numeric(e1) && (length(e1) == 1L))
        .String_from_string(paste(rep.int(e2, e1), collapse = ""))
    else if(is.numeric(e2) && (length(e2) == 1L))
        .String_from_string(paste(rep.int(e1, e2), collapse = ""))
    else
        stop("Invalid operands.")
}

## What about c.String?

.String_from_string <-
function(x)
{
    y <- enc2utf8(x)
    class(y) <- "String"
    y
}

### Format and print.

.format_TextDocument <-
function(x, ...)
    c(sprintf("<<%s>>", class(x)[1L]),
      sprintf("Metadata:  %d", length(meta(x))))

.print_via_format <-
function(x, ...) 
{
    writeLines(format(x, ...))
    invisible(x)
}

### Get and set metadata.

.get_meta_if_attr <-
function(x, tag = NULL, ...)
{
    m <- attr(x, "meta")
    if(is.null(tag)) m else m[[tag]]
}

.set_meta_if_attr <-
function(x, tag = NULL, ..., value)    
{
    if(is.null(tag))
        attr(x, "meta") <- value
    else
        attr(x, "meta")[[tag]] <- value
    x
}

.get_meta_if_slot <-
function(x, tag = NULL, ...)
    if(is.null(tag)) x$meta else x$meta[[tag]]

.set_meta_if_slot <-
function(x, tag = NULL, ..., value)
{
    if(is.null(tag))
        x$meta <- value
    else
        x$meta[[tag]] <- value
    x
}

## See <http://universaldependencies.org/format.html>.

read_CoNNLU <-
function(con)
{
    lines <- readLines(con, encoding = "UTF-8")
    ind_b <- lines == ""
    ind_c <- startsWith(lines, "#")
    ind <- !ind_b & !ind_c

    ## Now using scan(text = lines[ind]) to read in the records is
    ## possible but unbearably slow for large documents: instead, try to
    ## proceed "directly".

    ## records <- strsplit(lines[ind], "\t", fixed = TRUE)
    ## records <- as.data.frame(do.call(rbind, records),
    ##                          stringsAsFactors = FALSE)

    ## names(records) <-
    ##     c("ID", "FORM", "LEMMA", "UPOSTAG", "XPOSTAG", "FEATS", "HEAD", 
    ##       "DEPREL", "DEPS", "MISC")
    ## sent <- cumsum(ind_b) + 1L
    ## tab <- cbind(data.frame(sent = sent),
    ##              as.data.frame(do.call(cbind, records),
    ##                            stringsAsFactors = FALSE))[ind , ]

    pos <- which(ind_b)
    sent <- rep.int(seq_along(pos), diff(c(0L, pos)))
    tab <- cbind(data.frame(sent[ind]),
                 as.data.frame(do.call(rbind,
                                       strsplit(lines[ind], "\t",
                                                fixed = TRUE)),
                               stringsAsFactors = FALSE))
    names(tab) <-
        c("sent",
          "ID", "FORM", "LEMMA", "UPOSTAG", "XPOSTAG", "FEATS", "HEAD", 
          "DEPREL", "DEPS", "MISC")
    
    comments <- split(lines[ind_c], sent[ind_c])
    attr(tab, "comments") <- comments
    ## From CoNLL-U v2 on 'sent_id' and 'text' comments are compulsory
    ## for every sentence.  Be defensive and add these as attributes
    ## only if always available.
    ind <- startsWith(lines, "# sent_id =")
    if(all(diff(sent[ind]) == 1))
        attr(tab, "sent_id") <-
            sub("^# sent_id = *", "", lines[ind])
    ind <- startsWith(lines, "# text =")
    if(all(diff(sent[ind]) == 1))
        attr(tab, "text") <-
            sub("^# text = *", "", lines[ind])

    class(tab) <- c("CoNNLU_Annotation", "data.frame")
    tab
}

CoNLLUTextDocument <-
function(con, meta = list(), text = NULL)    
{
    tab <- read_CoNNLU(con)
    doc <- list(content = tab,
                meta = meta,
                text = if(is.null(text))
                           attr(tab, "text")
                       else text)
    class(doc) <- c("CoNLLUTextDocument", "TextDocument")
    doc
}

## CoNLL-U allows to represent both words and (multiword) tokens, which
## both have FORM entries, with ID single integers for words and integer
## ranges for the tokens.  We provide the tokens with as.character() and
## the words with the other "viewers", in particular, words().

format.CoNLLUTextDocument <-
function(x, ...)    
{
    y <- x$content
    ind <- !grepl("[.-]", y$ID)
    c(.format_TextDocument(x),
      sprintf("Content:  words: %d, sents: %d",
              sum(ind),
              y[NROW(y), "sent"]))
}
    
content.CoNLLUTextDocument <-
function(x)
    x$content

as.character.CoNLLUTextDocument <-
function(x, ...)
{
    if(!is.null(y <- x$text))
        y
    else
        otoks(x)
}

## <NOTE>
## All methods below could also be provided for CoNNLU_Annotation
## objects. 
## </NOTE>
    
otoks.CoNLLUTextDocument <-
function(x, ...)    
{
    y <- x$content
    ## Drop empty nodes.
    y <- y[!grepl(".", y$ID, fixed = TRUE), ]
    ## Expand ranges to determine forms to be skipped for tokens.
    ind <- grepl("-", y$ID, fixed = TRUE)
    ids <- y$ID[ind]
    skip <- Map(seq, sub("-.*", "", ids), sub(".*-", "", ids))
    skip <- paste(rep.int(y$sent[ind], lengths(skip)),
                  unlist(skip),
                  sep = ".")
    y$FORM[is.na(match(paste(y$sent, y$ID, sep = "."), skip))]
}

words.CoNLLUTextDocument <-
function(x, ...)    
{
    ind <- !grepl("[.-]", x$content$ID)
    x$content$FORM[ind]
}

sents.CoNLLUTextDocument <-
function(x, ...)    
{
    ind <- !grepl("[.-]", x$content$ID)
    split(x$content$FORM[ind],
          x$content$sent[ind])
}

tagged_words.CoNLLUTextDocument <-
function(x, which = c("UPOSTAG", "XPOSTAG"), ...)
{
    which <- match.arg(which)
    ind <- !grepl("[.-]", x$content$ID)
    Tagged_Token(x$content$FORM[ind],
                 x$content[[which]][ind])
}

tagged_sents.CoNLLUTextDocument <-
function(x, which = c("UPOSTAG", "XPOSTAG"), ...)
{
    which <- match.arg(which)
    ind <- !grepl("[.-]", x$content$ID)
    split(Tagged_Token(x$content$FORM[ind],
                       x$content[[which]][ind]),
          x$content$sent[ind])
}

AnnotatedPlainTextDocument <-
function(s, a, meta = list())
{
    s <- as.String(s)

    ## Be nice.
    a <- as.Annotation(a)

    doc <- list(content = s, annotation = a, meta = meta)
    class(doc) <- c("AnnotatedPlainTextDocument",
                    "PlainTextDocument",
                    "TextDocument")

    doc
}

format.AnnotatedPlainTextDocument <-
function(x, ...)
{        
    c(.format_TextDocument(x),
      sprintf("Annotations:  length: %s",
              length(x$annotation)),
      sprintf("Content:  chars: %d",
              nchar(x$content)))
}
    
content.AnnotatedPlainTextDocument <-
function(x)
    x$content

`content<-.AnnotatedPlainTextDocument` <-
function(x, value)
    stop("content modification is not possible for AnnotatedPlainTextDocument objects")

## meta.AnnotatedPlainTextDocument <-
## function(x, tag = NULL, ...)
##     if(is.null(tag)) x$meta else x$meta[[tag]]

## `meta<-.AnnotatedPlainTextDocument` <-
## function(x, tag = NULL, ..., value)
## {
##     if(is.null(tag))
##         x$meta <- value
##     else
##         x$meta[[tag]] <- value
##     x
## }

as.character.AnnotatedPlainTextDocument <-
function(x, ...)
    x$content

annotation <-
function(x)
{
    if(!inherits(x, "AnnotatedPlainTextDocument"))
        stop("argument 'x' must be an AnnotatedPlainTextDocument object")
    x$annotation
}

## NLTK style functions for high level access 

words.AnnotatedPlainTextDocument <-
function(x, ...)
{
    if(!inherits(x, "AnnotatedPlainTextDocument"))
        stop("argument 'x' must be an AnnotatedPlainTextDocument object")
    s <- x$content
    a <- x$annotation
    a <- a[a$type == "word"]
    .words_from_annotation_and_text(a, s)
}

.words_from_annotation_and_text <-
function(a, s)
{
    a <- a[a$type == "word"]
    w <- s[a]
    ## Use a word feature where available.
    f <- lapply(a$features, `[[`, "word")
    i <- (lengths(f) > 0L)
    w[i] <- unlist(f[i])
    w
}

sents.AnnotatedPlainTextDocument <-
function(x, ...)
{
    if(!inherits(x, "AnnotatedPlainTextDocument"))
        stop("argument 'x' must be an AnnotatedPlainTextDocument object")
    s <- x$content
    a <- x$annotation
    .sents_from_annotation_and_text(a, s)
}

.sents_from_annotation_and_text <-
function(a, s)
{
    a <- annotations_in_spans(a[a$type == "word"],
                              a[a$type == "sentence"])
    lapply(a, .words_from_annotation_and_text, s)
}

paras.AnnotatedPlainTextDocument <-
function(x, ...)
{
    if(!inherits(x, "AnnotatedPlainTextDocument"))
        stop("argument 'x' must be an AnnotatedPlainTextDocument object")
    s <- x$content
    a <- x$annotation
    lapply(annotations_in_spans(a, a[a$type == "paragraph"]),
           .sents_from_annotation_and_text, s)
}

tagged_words.AnnotatedPlainTextDocument <-
function(x, map = NULL, ...)
{
    if(!inherits(x, "AnnotatedPlainTextDocument"))
        stop("argument 'x' must be an AnnotatedPlainTextDocument object")
    s <- x$content
    a <- x$annotation
    a <- a[a$type == "word"]
    if(!is.null(map))
        a <- .map_POS_tags_Annotation(a, map)
    .tagged_words_from_annotation_and_text(a, s)
}

.tagged_words_from_annotation_and_text <-
function(a, s)
{
    pos <- .annotation_features_with_template(a, "POS")
    Tagged_Token(.words_from_annotation_and_text(a, s), pos)
}

tagged_sents.AnnotatedPlainTextDocument <-
function(x, map = NULL, ...)
{
    if(!inherits(x, "AnnotatedPlainTextDocument"))
        stop("argument 'x' must be an AnnotatedPlainTextDocument object")
    s <- x$content
    a <- x$annotation
    if(!is.null(map))
        a <- .map_POS_tags_Annotation(a, map)
    .tagged_sents_from_annotation_and_text(a, s)
}

.tagged_sents_from_annotation_and_text <-
function(a, s)
{
    lapply(annotations_in_spans(a[a$type == "word"],
                                a[a$type == "sentence"]),
           .tagged_words_from_annotation_and_text, s)
}

tagged_paras.AnnotatedPlainTextDocument <-
function(x, map = NULL, ...)
{
    if(!inherits(x, "AnnotatedPlainTextDocument"))
        stop("argument 'x' must be an AnnotatedPlainTextDocument object")
    s <- x$content
    a <- x$annotation
    if(!is.null(map))
        a <- .map_POS_tags_Annotation(a, map)
    lapply(annotations_in_spans(a, a[a$type == "paragraph"]),
           .tagged_sents_from_annotation_and_text, s)
}
           
parsed_sents.AnnotatedPlainTextDocument <-
function(x, ...)
{
    if(!inherits(x, "AnnotatedPlainTextDocument"))
        stop("argument 'x' must be an AnnotatedPlainTextDocument object")
    a <- x$annotation
    .parsed_sents_from_annotation(a)
}

.parsed_sents_from_annotation <-
function(a)
{
    a <- a[a$type == "sentence"]
    ptexts <- .annotation_features_with_template(a, "parse")
    lapply(ptexts, Tree_parse)
}

parsed_paras.AnnotatedPlainTextDocument <-
function(x, ...)
{
    if(!inherits(x, "AnnotatedPlainTextDocument"))
        stop("argument 'x' must be an AnnotatedPlainTextDocument object")
    a <- x$annotation
    lapply(annotations_in_spans(a, a[a$type == "paragraph"]),
           .parsed_sents_from_annotation)
}

chunked_sents.AnnotatedPlainTextDocument <-
function(x, ...)
{
    if(!inherits(x, "AnnotatedPlainTextDocument"))
        stop("argument 'x' must be an AnnotatedPlainTextDocument object")
    s <- x$content
    a <- x$annotation

    ## Require annotations with POS and chunk_tag features, as obtained
    ## e.g. with the Apache OpenNLP POS tag and chunk annotators.  We
    ## could alternatively use annotations with parse features and
    ## flatten the parse trees.

    lapply(annotations_in_spans(a[a$type == "word"],
                                a[a$type == "sentence"]),
           function(a) {
               ptags <- .annotation_features_with_template(a, "POS")
               ctags <- .annotation_features_with_template(a, "chunk_tag")
               words <- .words_from_annotation_and_text(a, s)
               chunk_tree_from_chunk_info(words, ptags, ctags)
           })
}

otoks.AnnotatedPlainTextDocument <-
function(x, ...)
{
    if (!inherits(x, "AnnotatedPlainTextDocument")) 
        stop("argument 'x' must be an AnnotatedPlainTextDocument object")
    s <- x$content
    a <- x$annotation
    a <- a[a$type == "word"]
    a <- a[!duplicated(sprintf("%d-%d", a$start, a$end))]
    s[a]
}

.map_POS_tags_Annotation <-
function(x, map)
{
    map <- POS_tag_mapper(map, meta(x, "POS_tagset"))
    x$features <-
        lapply(x$features,
               function(e) {
                   if(!is.null(pos <- e$POS))
                       e$POS <- map(pos)
                   e
               })
    x
}

.annotation_features_with_template <-
function(x, tag, FUN.VALUE = "")
{
    tryCatch(vapply(x$features, function(e) e[[tag]], FUN.VALUE),
             error = function(e) {
                 stop(sprintf("incomplete or invalid '%s' features",
                              tag),
                      call. = FALSE)
             })
}

## Viewer methods for objects of class "spacyr_parsed" as obtained by
## spacyr::spacy_parse().

words.spacyr_parsed <-
function(x, ...)
{
    x$token
}

sents.spacyr_parsed <-
function(x, ...)
{
    split(x$token, x$sentence_id)
}

tagged_words.spacyr_parsed <-
function(x, which = c("pos", "tag"), ...)
{
    which <- match.arg(which)
    Tagged_Token(x$token, x[[which]])
}

tagged_sents.spacyr_parsed <-
function(x, which = c("pos", "tag"), ...)
{
    which <- match.arg(which)
    lapply(split(x, x$sentence_id),
           function(e) Tagged_Token(e$token, e[[which]]))
}    

## Viewer methods for objects of class "udpipe_connlu" as obtained by
## udpipe::udpipe_annotate().

## <FIXME>
## All methods will need the udpipe namespace loaded to use the
## as.data.frame() method for class "udpipe_connlu".
## Should we check for this?
## Perhaps simply call loadNamespace("udpipe") in the methods?
## </FIXME>

words.udpipe_connlu <-
function(x, ...)
{
    x <- as.data.frame(x)
    x$token
}

sents.udpipe_connlu <-
function(x, ...)
{
    x <- as.data.frame(x)
    split(x$token, x$sentence_id)
}

paras.udpipe_connlu <-
function(x, ...)
{
    x <- as.data.frame(x)
    lapply(split(x, x$paragraph_id),
           function(e) split(e$token, e$sentence_id))
}

tagged_words.udpipe_connlu <-
function(x, which = c("upos", "xpos"), ...)
{
    x <- as.data.frame(x)
    which <- match.arg(which)
    Tagged_Token(x$token, x[[which]])
}

tagged_sents.udpipe_connlu <-
function(x, which = c("upos", "xpos"), ...)
{
    x <- as.data.frame(x)
    which <- match.arg(which)
    .tagged_sents_from_conllu_frame(x, which)
}

.tagged_sents_from_conllu_frame <-
function(x, which)
{
    lapply(split(x, x$sentence_id),
           function(e) Tagged_Token(e$token, e[[which]]))
}
    
tagged_paras.udpipe_connlu <-
function(x, which = c("upos", "xpos"), ...)
{
    x <- as.data.frame(x)
    which <- match.arg(which)
    lapply(split(x, x$paragraph_id),
           .tagged_sents_from_conllu_frame,
           which)
}

## Viewer methods for objects of class "cnlp_annotation" as obtained by
## cleanNLP::cnlp_annotate().

words.cnlp_annotation <-
function(x, ...)
{
    x$token$token
}

sents.cnlp_annotation <-
function(x, ...)
{
    x <- x$token
    split(x$token, x$sid)
}

## paras.cnlp_annotation <-
## function(x, ...)
## {
##     x <- x$token
##     if(is.na(match("pid", names(x))))
##         stop("unavailable paragraph ids")
##     lapply(split(x, x$pid),
##            function(e) split(e$token, e$sid))
## }

tagged_words.cnlp_annotation <-
function(x, which = c("upos", "pos"), ...)
{
    x <- x$token
    which <- match.arg(which)
    Tagged_Token(x$token, x[[which]])
}

tagged_sents.cnlp_annotation <-
function(x, which = c("upos", "pos"), ...)
{
    x <- x$token
    which <- match.arg(which)
    .tagged_sents_from_cnlp_token_frame(x, which)
}

.tagged_sents_from_cnlp_token_frame <-
function(x, which)
{
    lapply(split(x, x$sid),
           function(e) Tagged_Token(e$token, e[[which]]))
}

## tagged_paras.cnlp_annotation <-
## function(x, which = c("upos", "pos"), ...)
## {
##     x <- x$token
##     if(is.na(match("pid", names(x))))
##         stop("unavailable paragraph ids")
##     which <- match.arg(which)
##     lapply(split(x, x$pid),
##            .tagged_sents_from_cnlp_token_frame,
##            which)
## }

## Tokenizers break text up into words, phrases, symbols, or other
## meaningful elements called tokens, see e.g.
## <https://en.wikipedia.org/wiki/Tokenization_%28lexical_analysis%29>.
## This can be accomplished by returning the sequence of tokens, or the
## corresponding spans (character start and end positions).
## Apache OpenNLP provides a Tokenizer interface, with methods
## String[] tokenize() and Span[] tokenizePos() for the two variants.
## See e.g.
## <http://opennlp.apache.org/docs/1.5.3/apidocs/opennlp-tools/opennlp/tools/tokenize/Tokenizer.html>.
## NLTK provides an interface class nltk.tokenize.api.TokenizerI, for
## which subclasses must define a tokenize() method, and can define a
## span_tokenize() method.
## See e.g. <http://www.nltk.org/api/nltk.tokenize.html>.
## In R, this could be mimicked by having two generics for getting the
## tokens or spans, and have a virtual Tokenizer class for which
## extension classes must provide methods for at least one of the
## generics.
## However, it seems more natural to have tokenizers be *functions*
## (instead of interface classes) which can be called directly (instead
## of calling the respective generics), and have two "kinds" of such
## functions: token tokenizers and span tokenizers.  We use the class
## information to indicate the kind, which in turn allows to provide a
## generic mechanism for mapping between the two kinds (straightforward
## when going from spans to tokens, doable for the opposite direction).
## This also allows to "extract" both kinds of tokenizers from suitable
## annotators or annotator pipelines.
## For now, there is no underlying virtual Tokenizer class.

### * Span tokenizers

Span_Tokenizer <-
function(f, meta = list())
{
    attr(f, "meta") <- meta
    class(f) <- "Span_Tokenizer"
    f
}

as.Span_Tokenizer <-
function(x, ...)
    UseMethod("as.Span_Tokenizer")

as.Span_Tokenizer.Span_Tokenizer <-
function(x, ...)
    x

## For now, pass metadata as is.
as.Span_Tokenizer.Token_Tokenizer <-
function(x, ...)
{
    f <- function(s) {
        s <- as.String(s)
        spans_from_tokens(s, x(s))
    }
    Span_Tokenizer(f, meta(x))
}

## For now, do not pass metadata.
as.Span_Tokenizer.Annotator <-
as.Span_Tokenizer.Annotator_Pipeline <-
function(x, type = "word", ...)
{
    f <- function(s) {
        a <- x(as.String(s))
        as.Span(a[a$type == "word", ])
    }
    Span_Tokenizer(f)
}
        
is.Span_Tokenizer <-
function(x)
    inherits(x, "Span_Tokenizer")

format.Span_Tokenizer <-
function(x, ...)
{
    d <- meta(x, "description")
    if(is.null(d)) {
        "A span tokenizer."
    } else {
        c("A span tokenizer, with description",
          strwrap(d, indent = 2L, exdent = 2L))
    }
}

### * Token tokenizers

Token_Tokenizer <-
function(f, meta = list())    
{
    attr(f, "meta") <- meta
    class(f) <- "Token_Tokenizer"
    f
}

as.Token_Tokenizer <-
function(x, ...)
    UseMethod("as.Token_Tokenizer")

as.Token_Tokenizer.Token_Tokenizer <-
function(x, ...)
    x

## For now, pass metadata as is.
as.Token_Tokenizer.Span_Tokenizer <-
function(x, ...)
{
    f <- function(s) {
        s <- as.String(s)
        s[x(s)]
    }
    Token_Tokenizer(f, meta(x))
}
    
## For now, do not pass metadata.
as.Token_Tokenizer.Annotator <-
as.Token_Tokenizer.Annotator_Pipeline <-
function(x, type = "word", ...)
{
    f <- function(s) {
        s <- as.String(s)
        a <- x(s)
        s[a[a$type == "word", ]]
    }
    Token_Tokenizer(f)
}

is.Token_Tokenizer <-
function(x)
    inherits(x, "Token_Tokenizer")

format.Token_Tokenizer <-
function(x, ...)
{
    d <- meta(x, "description")
    if(is.null(d)) {
        "A token tokenizer."
    } else {
        c("A token tokenizer, with description",
          strwrap(d, indent = 2L, exdent = 2L))
    }
}   

### Regexp span tokenizers a la NLTK.

Regexp_Tokenizer <-
function(pattern, invert = FALSE, ..., meta = list())
{
    force(pattern)
    args <- list(...)
    
    f <- if(invert) {
        ## Pattern gives the separators.
        function(s) {
            s <- as.String(s)
            if(is.na(s) || !nchar(s))
                stop("Need a non-empty string.")
            m <- do.call(gregexpr,
                         c(list(pattern = pattern, text = s), args))[[1L]]
            if((length(m) == 1L) && (m == -1L))
                return(Span(1L, nchar(s)))
            start <- c(1L, m + attr(m, "match.length"))
            end <- c(m - 1L, nchar(s))
            ind <- start <= end
            Span(start[ind], end[ind])
        }
    } else {
        ## Pattern gives the tokens.
        function(s) {
            s <- as.String(s)
            if(is.na(s) || !nchar(s))
                stop("Need a non-empty string.")
            m <- do.call(gregexpr,
                         c(list(pattern = pattern, text = s), args))[[1L]]
            Span(m, m + attr(m, "match.length") - 1L)
        }
    }

    Span_Tokenizer(f, meta)
}

whitespace_tokenizer <-
    Regexp_Tokenizer("\\s+",
                     invert = TRUE,
                     meta = list(description = "Divides strings into substrings by treating any sequence of whitespace characters as a separator."))

blankline_tokenizer <-
    Regexp_Tokenizer("\\s*\n\\s*\\n\\s*",
                     invert = TRUE,
                     meta = list(description = "Divides strings into substrings by treating any sequence of blank lines as a separator."))

wordpunct_tokenizer <-
    Regexp_Tokenizer("\\w+|[^\\w\\s]+",
                     perl = TRUE,
                     meta = list(description = "Divides strings into substrings of alphabetic and (non-whitespace) non-alphabetic characters."))

### * Utilities

spans_from_tokens <-
function(x, tokens)
{
    start <- end <- integer(length(tokens))
    off <- 0L
    for(i in seq_along(tokens)) {
        m <- regexpr(tokens[i], x, fixed = TRUE)
        pos <- m + attr(m, "match.length")
        x <- substring(x, pos)
        start[i] <- off + m
        end[i] <- off <- off + pos - 1L
        
    }
    Span(start, end)
}

words <-
function(x, ...)
    UseMethod("words")

sents <-
function(x, ...)
    UseMethod("sents")

paras <-
function(x, ...)
    UseMethod("paras")

tagged_words <-
function(x, ...)
    UseMethod("tagged_words")

tagged_sents <-
function(x, ...)
    UseMethod("tagged_sents")

tagged_paras <-
function(x, ...)
    UseMethod("tagged_paras")

chunked_sents <-
function(x, ...)
    UseMethod("chunked_sents")

parsed_sents <-
function(x, ...)
    UseMethod("parsed_sents")

parsed_paras <-
function(x, ...)
    UseMethod("parsed_paras")

otoks <-
function(x, ...)
    UseMethod("otoks")

chunk_tree_from_chunk_info <-
function(words, ptags, ctags)
{
    ind <- grepl("^[BO]", ctags)
    ## <FIXME>
    ## Should this also use Tagged_Token()?
    chunks <- split(sprintf("%s/%s", words, ptags), cumsum(ind))
    ## </FIXME>
    nms <- sub(".*-", "", ctags[ind])
    ind <- nms != "O"
    chunks[ind] <- Map(Tree, nms[ind], chunks[ind])
    Tree("S", chunks)
}

POS_tag_mapper <-
function(map, set)
{
    if(is.function(map))
        return(map)
    if(is.list(map))
        map <- map[[set]]
    function(pos) map[pos]
}

ngrams <-
function(x, n)
{
    N <- length(x)
    n <- n[(n >= 1L) & (n <= N)]
    lapply(unlist(lapply(n,
                         function(k) {
                             pos <- seq_len(k)
                             lapply(seq.int(0, N - k),
                                    `+`, pos)
                         }),
                  recursive = FALSE),
           function(e) x[e])
}

## All annotators should have formals s and a, giving the string to
## annotate and an annotation to start from, and return "their own"
## annotation. 

Annotator <-
function(f, meta = list(), classes = NULL)
{
    if(!identical(names(formals(f)), c("s", "a")))
        stop("Annotators must have formals 's' and 'a'.")
    attr(f, "meta") <- meta
    class(f) <- .classes_with_default(classes, "Annotator")
    f
}

is.Annotator <-
function(x)
    inherits(x, "Annotator")

format.Annotator <-
function(x, ...)
{
    d <- meta(x, "description")
    c(sprintf("An annotator inheriting from classes\n  %s",
              paste(class(x), collapse = " ")),
      if(is.null(d)) {
          "with no additional description."
      } else {
          c("with description",
            strwrap(d, indent = 2L, exdent = 2L))
      })
}

## Annotator generators.

## Provide annotator generators for composite basic NLP tasks (e.g.,
## obtaining POS tags for the tokens in all sentences) based on
## functions which perform simple tasks (e.g., obtaining POS tags for
## the token in a single sentence) and return spans/features or simple
## annotations (but do not provide ids themselves).

Simple_Para_Token_Annotator <-
function(f, meta = list(), classes = NULL)
{
    ## f should be a simple paragraph tokenizer, which takes a string s
    ## representing the whole text, and returns the spans of the
    ## paragraphs in s, or a simple annotation with these spans and
    ## (possibly) additional features.

    force(f)
    
    default <- "Simple_Para_Token_Annotator"
    classes <- .classes_with_default(classes, default)

    g <- function(s, a = Annotation()) {
        s <- as.String(s)
        y <- f(s)
        n <- length(y)
        id <- .seq_id(next_id(a$id), n)
        type <- rep.int("paragraph", n)
        if(is.Annotation(y)) {
            ## Could check whether ids are really missing.
            y$id <- id
            y$type <- type              # Just making sure ...
        } else if(is.Span(y)) {
            y <- as.Annotation(y, id = id, type = type)
        } else
            stop("Invalid result from underlying paragraph tokenizer.")
        y
    }

    Annotator(g, meta, classes)
}

Simple_Sent_Token_Annotator <-
function(f, meta = list(), classes = NULL)
{
    ## f should be a simple sentence tokenizer, which takes a string s
    ## representing the whole text, and returns the spans of the
    ## sentences in s, or a simple annotation with these spans and
    ## (possibly) additional features.

    ## Note that in case paragraph annotations are available, we
    ## (currently) do not split the whole text into paragraphs before
    ## performing sentence tokenization.  Instead, we add a sentence
    ## constituents feature for the paragraphs.

    force(f)    

    default <- "Simple_Sent_Token_Annotator"
    classes <- .classes_with_default(classes, default)

    g <- function(s, a = Annotation()) {
        s <- as.String(s)
        y <- f(s)
        n <- length(y)
        id <- .seq_id(next_id(a$id), n)
        type <- rep.int("sentence", n)
        if(is.Annotation(y)) {
            ## Could check whether ids are really missing.
            y$id <- id
            y$type <- type              # Just making sure ...
        } else if(is.Span(y)) {
            y <- as.Annotation(y, id = id, type = type)
        } else
            stop("Invalid result from underlying sentence tokenizer.")

        if(length(i <- which(a$type == "paragraph"))) {
            a <- a[i]
            a$features <- lapply(annotations_in_spans(y, a),
                                 function(e) list(constituents = e$id))
            y <- c(y, a)
        }

        y
    }

    Annotator(g, meta, classes)
}

Simple_Word_Token_Annotator <-
function(f, meta = list(), classes = NULL)
{
    ## f should be a simple "word" tokenizer, which takes a string s
    ## representing a single sentence, and returns the spans of the word
    ## tokens in s, or a simple annotation with these spans and
    ## (possibly) additional features.
    
    ## The generated annotator adds the sentence offsets and unique
    ## word token ids, and constituents features for the sentences.

    force(f)

    default <- "Simple_Word_Token_Annotator"
    classes <- .classes_with_default(classes, default)
    
    g <- function(s, a) {
        s <- as.String(s)

        ## Use the given annotation to extract the sentences.
        i <- which(a$type == "sentence")
        if(!length(i))
            stop("no sentence token annotations found")            

        ## Obtain the results of the word tokenizer for these sentences.
        y <- lapply(substring(s, a$start[i], a$end[i]), f)
        ## Compute ids for the word tokens, and turn results into
        ## annotations.
        ## If m is the maximal id used in a and sentence i has n_i
        ## tokens, then the ids for these start from
        ##   m + 1 + sum(n_j: j < i)
        ## and have length n_i, of course.
        if(all(vapply(y, is.Annotation, NA))) {
            y <- Map(function(u, v) {
                         u$start <- u$start + v
                         u$end <- u$end + v
                         u
                     },
                     y,
                     a$start[i] - 1L)
            n <- lengths(y)
            id <- Map(.seq_id,
                      next_id(a$id) + c(0L, cumsum(head(n, -1L))),
                      n)
            type <- Map(rep.int, "word", n)
            y <- Map(function(u, id, type) {
                         u$id <- id
                         u$type <- type # Just making sure ...
                         u
                     },
                     y, id, type)
        } else if(all(vapply(y, is.Span, NA))) {
            y <- Map(`+`, y, a$start[i] - 1L) # Add sentence offsets.
            n <- lengths(y)
            id <- Map(.seq_id,
                      next_id(a$id) + c(0L, cumsum(head(n, -1L))),
                      n)
            type <- Map(rep.int, "word", n)
            y <- Map(function(u, id, type)
                     as.Annotation(u, id = id, type = type),
                     y, id, type)
        } else
            stop("Invalid result from underlying word tokenizer.")

        ## Constituent features for the sentences.
        a <- a[i]
        a$features <- lapply(id, single_feature, "constituents")

        ## Combine sentence annotation with constituent features and the
        ## word token annotations.
        c(a, do.call(c, y))
    }

    Annotator(g, meta, classes)
}

Simple_POS_Tag_Annotator <-
function(f, meta = list(), classes = NULL)
{
    ## f should be a simple POS tagger, which takes a character vector
    ## giving the word tokens in a sentence, and returns either a
    ## character vector with the tags, or a list of feature maps with
    ## the tags as 'POS' feature and possibly other features.

    ## The generated annotator simply computes an annotation for the
    ## word tokens with the features obtained from the POS tagger.

    force(f)
    
    default <- "Simple_POS_Tag_Annotator"
    classes <- .classes_with_default(classes, default)

    g <- function(s, a) {
        s <- as.String(s)

        a <- annotations_in_spans(a[a$type == "word"],
                                  a[a$type == "sentence"])
        if(!length(a))
            stop("no sentence token annotations found")
        if(!any(lengths(a) > 0L))
            stop("no word token annotations found")

        y <- lapply(s[a], f)
        if(all(vapply(y, is.character, NA)))
            features <- lapply(unlist(y), single_feature, "POS")
        else if(all(vapply(y, is.list, NA)))
            features <- unlist(y, recursive = FALSE)
        else 
            stop("Invalid result from underlying POS tagger.")

        a <- do.call(c, a)
        a$features <- features

        ## As simple POS taggers do not return annotations, information
        ## about the POS tagset cannot be passed as annotation metadata.
        ## Instead, for now we look for a 'POS_tagset' attribute.
        ## Similarly for 'POS_tagset_URL'.
        for(tag in c("POS_tagset", "POS_tagset_URL")) {
            if(!is.null(val <- attr(f, tag)))
                attr(a, "meta")[[tag]] <- val
        }
        
        a
    }
    
    Annotator(g, meta, classes)
}

Simple_Entity_Annotator <-
function(f, meta = list(), classes = NULL)
{
    ## f should be a simple entity detector ("named entity recognizer") 
    ## which takes a character vector giving the word tokens in a
    ## sentence, and return a simple annotation containing the word
    ## token spans and types of the entities found.

    ## The generated annotator adds ids and transforms word token spans
    ## to character spans.

    force(f)

    default <- "Simple_Entity_Annotator"
    classes <- .classes_with_default(classes, default)

    g <- function(s, a) {
        s <- as.String(s)

        i <- next_id(a$id)
        a <- annotations_in_spans(a[a$type == "word"],
                                  a[a$type == "sentence"])
        if(!length(a))
            stop("no sentence token annotations found")
        if(!any(lengths(a) > 0L))
            stop("no word token annotations found")

        y <- lapply(a,
                    function(e) {
                        result <- f(s[e])
                        if(!inherits(result, "Annotation"))
                            stop("Invalid result from underlying name finder.")
                        result$start <- e$start[result$start]
                        result$end <- e$end[result$end]
                        result
                    })
                        
        y <- do.call(c, y)
        y$id <- .seq_id(i, length(y))

        y
    }
    
    Annotator(g, meta, classes)
}

Simple_Chunk_Annotator <-
function(f, meta = list(), classes = NULL)
{
    ## f should be a simple chunker, which takes character vectors
    ## giving the word tokens and the corresponding POS tags as inputs,
    ## and returns either a character vector with the chunk tags, or a
    ## list of feature maps with the tags as 'chunk_tag' feature and
    ## possibly other features.

    ## The generated annotator simply extracts the word token
    ## annotations for the sentences, obtains the chunk features for
    ## these, and returns the word token annotations with these features
    ## (only).

    force(f)

    default <- "Simple_Chunk_Annotator"
    classes <- .classes_with_default(classes, default)

    g <- function(s, a) {
        s <- as.String(s)

        a <- annotations_in_spans(a[a$type == "word"],
                                  a[a$type == "sentence"])
        if(!length(a))
            stop("no sentence token annotations found")
        if(!any(lengths(a) > 0L))
            stop("no word token annotations found")

        y <- lapply(a,
                    function(e)
                        f(s[e],
                          .annotation_features_with_template(e, "POS")))
        if(all(vapply(y, is.character, NA)))
            features <- lapply(unlist(y), single_feature, "chunk_tag")
        else if(all(vapply(y, is.list, NA)))
            features <- unlist(y, recursive = FALSE)
        else 
            stop("Invalid result from underlying chunker.")

        a <- do.call(c, a)
        a$features <- features
        a
    }

    Annotator(g, meta, classes)
}

Simple_Stem_Annotator <-
function(f, meta = list(), classes = NULL)
{
    ## f should be a simple stemmer, which takes a character vector of
    ## word tokens and returns the corresponding word stems.

    ## The generated annotator simply computes an annotation for the
    ## word tokens with the stem features obtained from the stemmer.

    force(f)

    default <- "Simple_Stem_Annotator"
    classes <- .classes_with_default(classes, default)

    g <- function(s, a) {
        s <- as.String(s)

        a <- a[a$type == "word"]

        a$features <- lapply(f(s[a]), single_feature, "stem")

        a
    }

    Annotator(g, meta, classes)
}
    
sentence_constituents <-
function(a)
{
    i <- which(a$type == "sentence")
    constituents <- lapply(a$features[i], `[[`, "constituents")
    if(!all(lengths(constituents) > 0L)) {
        ## Looks like we have an annotation with no constituents
        ## features for the sentences ... need to compute these.
        ## Make sure sentences are ordered by character offsets.
        i <- i[order(a$end[i])]
        j <- which(a$type == "word")
        ## Should we also make sure tokens are ordered by character
        ## offsets?
        k <- rowSums(outer(a$start[j], a$start[i], `>=`))
        constituents <- split(a$id[j], k)
        names(constituents) <- a$id[i][as.integer(names(constituents))]
        ## Assuming there can not be empty sentences, we could more
        ## simply do
        ##   names(constituents) <- a$id[i]
    }
    else
        names(constituents) <- a$id[i]
    constituents
}

next_id <-
function(id)
    .max_id(id) + 1L

single_feature <-
function(value, tag)
{
    y <- list(value)
    names(y) <- tag
    y
}

.max_id <-
function(id)
{
    id <- id[!is.na(id)]
    if(!length(id)) 0L else max(id)
}

.seq_id <-
function(f, l)
    as.integer(seq.int(from = f, length.out = l))

.classes_with_default <-
function(classes, default)
    c(classes[classes != default], default)

## .simple_feature_map <-
## function(x, tag)
## {
##     ## Turn a sequence of values x into a list of feature maps with
##     ## given tag and respective values in x.
##     lapply(x, single_feature, tag)
## }

### * Annotator pipelines

Annotator_Pipeline <-
function(..., meta = list())
{
    x <- list(...)
    if(!all(vapply(x, is.Annotator, FALSE)))
        stop("all pipeline elements must be annotator objects")
    .Annotator_Pipeline_from_list_and_meta(x, meta)
}

## <FIXME>
## Should we move the is.Annotator checking here, perhaps with a way to
## turn it off?
.Annotator_Pipeline_from_list_and_meta <-
function(x, meta = list())
{
    attr(x, "meta") <- meta
    class(x) <- "Annotator_Pipeline"
    x
}
## </FIXME>

as.Annotator_Pipeline <-
function(x)
    UseMethod("as.Annotator_Pipeline")

as.Annotator_Pipeline.Annotator_Pipeline <-
    identity

as.Annotator_Pipeline.Annotator <-
function(x)
    .Annotator_Pipeline_from_list_and_meta(list(x))

as.Annotator_Pipeline.list <-
function(x)
{
    if(!all(vapply(x, is.Annotator, FALSE)))
        stop("all pipeline elements must be annotator objects")
    .Annotator_Pipeline_from_list_and_meta(x)
}

`[.Annotator_Pipeline` <-
function(x, i)
    .Annotator_Pipeline_from_list_and_meta(unclass(x)[i], meta(x))

as.list.Annotator_Pipeline <-
function(x, ...)
{
    x <- unclass(x)
    attr(x, "meta") <- NULL
    x
}

## No merging of metadata for now.
c.Annotator_Pipeline <-
function(..., recursive = FALSE)
{
    annotators <- unlist(lapply(list(...), as.Annotator_Pipeline),
                         recursive = FALSE)
    .Annotator_Pipeline_from_list_and_meta(annotators)
}

format.Annotator_Pipeline <-
function(x, ...)
    sprintf("An annotator pipeline of length %d.", length(x))

## annotate() can use a single annotator or an annotator pipeline or
## something coercible to this, such as a list of annotators, and
## recursively calls the given annotators and merges annotations.

annotate <-
function(s, f, a = Annotation())
{
    s <- as.String(s)
    for(e in as.Annotator_Pipeline(f))
        a <- merge(a, e(s, a))

    a
}

content <-
function(x)
    UseMethod("content", x)

`content<-` <-
function(x, value)
    UseMethod("content<-", x)

meta <-
function(x, tag = NULL, ...)
    UseMethod("meta", x)

`meta<-` <-
function(x, tag = NULL, ..., value)
    UseMethod("meta<-", x)

\name{AnnotatedPlainTextDocument}
\alias{AnnotatedPlainTextDocument}
\alias{annotation}
\title{Annotated Plain Text Documents}
\description{
  Create annotated plain text documents from plain text and collections
  of annotations for this text.
}
\usage{
AnnotatedPlainTextDocument(s, a, meta = list())
annotation(x)
}
\arguments{
  \item{s}{a \code{\link{String}} object, or something coercible to this
    using \code{\link{as.String}()} (e.g., a character string with
    appropriate encoding information).}
  \item{a}{an \code{\link{Annotation}} object with annotations for
    \code{s}.}
  \item{meta}{a named or empty list of document metadata tag-value
    pairs.}
  \item{x}{an object inheriting from class
    \code{"AnnotatedPlainTextDocument"}.}
}
\details{
  Annotated plain text documents combine plain text with annotations for
  the text.

  A typical workflow is to use \code{\link{annotate}()} with suitable
  annotator pipelines to obtain the annotations, and then use
  \code{AnnotatedPlainTextDocument()} to combine these with the text
  being annotated.  This yields an object inheriting from
  \code{"AnnotatedPlainTextDocument"} and \code{"\link{TextDocument}"},
  from which the text and annotations can be obtained using,
  respectively, \code{\link{as.character}()} and \code{annotation()}.

  There are methods for class \code{"AnnotatedPlainTextDocument"} and
  generics
  \code{\link{words}()},
  \code{\link{sents}()},
  \code{\link{paras}()},
  \code{\link{tagged_words}()},
  \code{\link{tagged_sents}()},
  \code{\link{tagged_paras}()},
  \code{\link{chunked_sents}()},
  \code{\link{parsed_sents}()} and
  \code{\link{parsed_paras}()}
  providing structured views of the text in such documents.  These all
  require the necessary annotations to be available in the annotation
  object used.

  The methods for generics
  \code{\link{tagged_words}()},
  \code{\link{tagged_sents}()} and
  \code{\link{tagged_paras}()}
  provide a mechanism for mapping POS tags via the \code{map} argument,
  see section \bold{Details} in the help page for
  \code{\link{tagged_words}()} for more information.
  The POS tagset used will be inferred from the \code{POS_tagset}
  metadata element of the annotation object used.
}
\value{
  For \code{AnnotatedPlainTextDocument()}, an annotated plain text
  document object inheriting from
  \code{"AnnotatedPlainTextTextDocument"} and
  \code{"\link{TextDocument}"}.

  For \code{annotation()}, an \code{\link{Annotation}} object.
}
\seealso{
  \code{\link{TextDocument}} for basic information on the text document
  infrastructure employed by package \pkg{NLP}.
}
\examples{
## Use a pre-built annotated plain text document obtained by employing an
## annotator pipeline from package 'StanfordCoreNLP', available from the
## repository at <https://datacube.wu.ac.at>, using the following code:
##   require("StanfordCoreNLP")
##   s <- paste("Stanford University is located in California.",
##              "It is a great university.")
##   p <- StanfordCoreNLP_Pipeline(c("pos", "lemma", "parse"))
##   d <- AnnotatedPlainTextDocument(s, p(s))

d <- readRDS(system.file("texts", "stanford.rds", package = "NLP"))

d

## Extract available annotation:
a <- annotation(d)
a

## Structured views:
sents(d)
tagged_sents(d)
tagged_sents(d, map = Universal_POS_tags_map)
parsed_sents(d)

## Add (trivial) paragraph annotation:
s <- as.character(d)
a <- annotate(s, Simple_Para_Token_Annotator(blankline_tokenizer), a)
d <- AnnotatedPlainTextDocument(s, a)
## Structured view:
paras(d)
}

\name{Tokenizer}
\alias{Span_Tokenizer}
\alias{as.Span_Tokenizer}
\alias{is.Span_Tokenizer}
\alias{Token_Tokenizer}
\alias{as.Token_Tokenizer}
\alias{is.Token_Tokenizer}
\title{Tokenizer objects}
\description{
  Create tokenizer objects.
}
\usage{
Span_Tokenizer(f, meta = list())
as.Span_Tokenizer(x, ...)
is.Span_Tokenizer(x)

Token_Tokenizer(f, meta = list())
as.Token_Tokenizer(x, ...)
is.Token_Tokenizer(x)
}
\arguments{
  \item{f}{a tokenizer function taking the string to tokenize as
    argument, and returning either the tokens (for
    \code{Token_Tokenizer}) or their spans (for
    \code{Span_Tokenizer}).}
  \item{meta}{a named or empty list of tokenizer metadata tag-value
    pairs.}
  \item{x}{an \R object.}
  \item{...}{further arguments passed to or from other methods.}
}
\details{
  Tokenization is the process of breaking a text string up into words,
  phrases, symbols, or other meaningful elements called tokens.  This
  can be accomplished by returning the sequence of tokens, or the
  corresponding spans (character start and end positions).
  We refer to tokenization resources of the respective kinds as
  \dQuote{token tokenizers} and \dQuote{span tokenizers}.

  \code{Span_Tokenizer()} and \code{Token_Tokenizer()} return tokenizer
  objects which are functions with metadata and suitable class
  information, which in turn can be used for converting between the two
  kinds using \code{as.Span_Tokenizer()} or \code{as.Token_Tokenizer()}.
  It is also possible to coerce annotator (pipeline) objects to
  tokenizer objects, provided that the annotators provide suitable
  token annotations.  By default, word tokens are used; this can be
  controlled via the \code{type} argument of the coercion methods (e.g.,
  use \code{type = "sentence"} to extract sentence tokens).

  There are also \code{print()} and \code{format()} methods for
  tokenizer objects, which use the \code{description} element of the
  metadata if available.
}
\seealso{
  \code{\link{Regexp_Tokenizer}()} for creating regexp span tokenizers.
}
\examples{
## A simple text.
s <- String("  First sentence.  Second sentence.  ")
##           ****5****0****5****0****5****0****5**

## Use a pre-built regexp (span) tokenizer:
wordpunct_tokenizer
wordpunct_tokenizer(s)
## Turn into a token tokenizer:
tt <- as.Token_Tokenizer(wordpunct_tokenizer)
tt
tt(s)
## Of course, in this case we could simply have done
s[wordpunct_tokenizer(s)]
## to obtain the tokens from the spans.
## Conversion also works the other way round: package 'tm' provides
## the following token tokenizer function:
scan_tokenizer <- function(x)
    scan(text = as.character(x), what = "character", quote = "", 
         quiet = TRUE)
## Create a token tokenizer from this:
tt <- Token_Tokenizer(scan_tokenizer)
tt(s)
## Turn into a span tokenizer:
st <- as.Span_Tokenizer(tt)
st(s)
## Checking tokens from spans:
s[st(s)]
}

\name{Annotator}
\alias{Annotator}
\alias{Annotator_Pipeline}
\alias{as.Annotator_Pipeline}
\title{Annotator (pipeline) objects}
\description{
  Create annotator (pipeline) objects.
}
\usage{
Annotator(f, meta = list(), classes = NULL)
Annotator_Pipeline(..., meta = list())
as.Annotator_Pipeline(x)
}
\arguments{
  \item{f}{an annotator function, which must have formals \code{s} and
    \code{a} giving, respectively, the string with the natural language
    text to annotate and an annotation object to start from, and return
    an annotation object with the computed annotations.}
  \item{meta}{an empty or named list of annotator (pipeline) metadata
    tag-value pairs.}
  \item{classes}{a character vector or \code{NULL} (default) giving
    classes to be used for the created annotator object in addition to
    \code{"Annotator"}.}
  \item{...}{annotator objects.}
  \item{x}{an \R object.}
}
\details{
  \code{Annotator()} checks that the given annotator function has the
  appropriate formals, and returns an annotator object which inherits
  from the given classes and \code{"Annotator"}.  There are
  \code{print()} and \code{format()} methods for such objects, which use
  the \code{description} element of the metadata if available.

  \code{Annotator_Pipeline()} creates an annotator pipeline object from
  the given annotator objects.  Such pipeline objects can be used by
  \code{\link{annotate}()} for successively computing and merging
  annotations, and can also be obtained by coercion with
  \code{as.Annotator_Pipeline()}, which currently handles annotator
  objects and lists of such (and of course, annotator pipeline
  objects).
}
\value{
  For \code{Annotator()}, an annotator object inheriting from the given
  classes and class \code{"Annotator"}.

  For \code{Annotator_Pipeline()} and \code{as.Annotator_Pipeline()}, an
  annotator pipeline object inheriting from class
  \code{"Annotator_Pipeline"}.
}
\seealso{
  \link{Simple annotator generators} for creating \dQuote{simple}
  annotator objects based on function performing simple basic NLP tasks.

  Package \pkg{StanfordCoreNLP} available from the repository at
  \url{https://datacube.wu.ac.at} which provides generators for annotator
  pipelines based on the Stanford CoreNLP tools.
}
\examples{
## Use blankline_tokenizer() for a simple paragraph token annotator:
para_token_annotator <-
Annotator(function(s, a = Annotation()) {
              spans <- blankline_tokenizer(s)
              n <- length(spans)
              ## Need n consecutive ids, starting with the next "free"
              ## one:
              from <- next_id(a$id)
              Annotation(seq(from = from, length.out = n),
                         rep.int("paragraph", n),
                         spans$start,
                         spans$end)
          },
          list(description = 
              "A paragraph token annotator based on blankline_tokenizer()."))
para_token_annotator
## Alternatively, use Simple_Para_Token_Annotator().

## A simple text with two paragraphs:
s <- String(paste("  First sentence.  Second sentence.  ",
                  "  Second paragraph.  ",
                  sep = "\n\n"))
a <- annotate(s, para_token_annotator)
## Annotations for paragraph tokens.
a
## Extract paragraph tokens.
s[a]
}

\name{String}
\alias{String}
\alias{as.String}
\alias{is.String}
\title{String objects}
\description{
  Creation and manipulation of string objects.
}
\usage{
String(x)
as.String(x)
is.String(x)
}
\arguments{
  \item{x}{a character vector with the appropriate encoding information
    for \code{String()}; an arbitrary \R object otherwise.
  }
}
\details{
  String objects provide character strings encoded in UTF-8 with class
  \code{"String"}, which currently has a useful \code{[} subscript
  method: with indices \code{i} and \code{j} of length one, this gives a
  string object with the substring starting at the position given by
  \code{i} and ending at the position given by \code{j}; subscripting
  with a single index which is an object inheriting from class
  \code{"\link{Span}"} or a list of such objects returns a character
  vector of substrings with the respective spans, or a list thereof.

  Additional methods may be added in the future.

  \code{String()} creates a string object from a given character vector,
  taking the first element of the vector and converting it to UTF-8
  encoding.

  \code{as.String()} is a generic function to coerce to a string object.
  The default method calls \code{String()} on the result of converting
  to character and concatenating into a single string with the elements
  separated by newlines.

  \code{is.String()} tests whether an object inherits from class
  \code{"String"}.
}
\value{
  For \code{String()} and \code{as.String()}, a string object (of class 
  \code{"String"}).

  For \code{is.String()}, a logical.
}
\examples{
## A simple text.
s <- String("  First sentence.  Second sentence.  ")
##           ****5****0****5****0****5****0****5**

## Basic sentence and word token annotation for the text.
a <- c(Annotation(1 : 2,
                  rep.int("sentence", 2L),
                  c( 3L, 20L),
                  c(17L, 35L)),
       Annotation(3 : 6,
                  rep.int("word", 4L),
                  c( 3L,  9L, 20L, 27L),
                  c( 7L, 16L, 25L, 34L)))

## All word tokens (by subscripting with an annotation object):
s[a[a$type == "word"]]
## Word tokens according to sentence (by subscripting with a list of
## annotation objects):
s[annotations_in_spans(a[a$type == "word"], a[a$type == "sentence"])]
}

\name{annotations_in_spans}
\alias{annotations_in_spans}
\title{Annotations contained in character spans}
\description{
  Extract annotations contained in character spans.
}
\usage{
annotations_in_spans(x, y)
}
\arguments{
  \item{x}{an \code{\link{Annotation}} object.}
  \item{y}{a \code{\link{Span}} object, or something coercible to this
    (such as an \code{\link{Annotation}} object).}
}
\value{
  A list with elements the annotations in \code{x} with character spans
  contained in the respective elements of \code{y}.
}
\examples{
## A simple text.
s <- String("  First sentence.  Second sentence.  ")
##           ****5****0****5****0****5****0****5**

## Basic sentence and word token annotation for the text.
a <- c(Annotation(1 : 2,
                  rep.int("sentence", 2L),
                  c( 3L, 20L),
                  c(17L, 35L)),
       Annotation(3 : 6,
                  rep.int("word", 4L),
                  c( 3L,  9L, 20L, 27L),
                  c( 7L, 16L, 25L, 34L)))

## Annotation for word tokens according to sentence:
annotations_in_spans(a[a$type == "word"], a[a$type == "sentence"])
}

\name{generics}
\alias{content}
\alias{content<-}
\alias{meta}
\alias{meta<-}
\title{Access or Modify Content or Metadata}
\description{
  Access or modify the content or metadata of \R objects.
}
\usage{
content(x)
content(x) <- value
meta(x, tag = NULL, ...)
meta(x, tag = NULL, ...) <- value
}
\arguments{
  \item{x}{an \R object.}
  \item{value}{a suitable \R object.}
  \item{tag}{a character string or \code{NULL} (default), indicating to
    return the single metadata value for the given tag, or all metadata
    tag/value pairs.}
  \item{...}{arguments to be passed to or from methods.}
}
\details{
  These are generic functions, with no default methods.

  Often, classed \R objects (e.g., those representing text documents in
  packages \pkg{NLP} and \pkg{tm}) contain information that can be
  grouped into \dQuote{content}, metadata and other components, where
  content can be arbitrary, and metadata are collections of tag/value
  pairs represented as named or empty lists.  The \code{content()} and
  \code{meta()} getters and setters aim at providing a consistent
  high-level interface to the respective information (abstracting from
  how classes internally represent the information).
}
\value{
  Methods for \code{meta()} should return a named or empty list of
  tag/value pairs if no tag is given (default), or the value for the
  given tag.
}
\seealso{
  \code{\link{TextDocument}} for basic information on the text document
  infrastructure employed by package \pkg{NLP}.
}

\name{viewers}
\alias{sents}
\alias{words}
\alias{paras}
\alias{tagged_sents}
\alias{tagged_paras}
\alias{tagged_words}
\alias{chunked_sents}
\alias{parsed_sents}
\alias{parsed_paras}
\alias{otoks}
\title{Text Document Viewers}
\description{
  Provide suitable \dQuote{views} of the text contained in text
  documents.
}
\usage{
words(x, ...)
sents(x, ...)
paras(x, ...)
tagged_words(x, ...)
tagged_sents(x, ...)
tagged_paras(x, ...)
chunked_sents(x, ...)
parsed_sents(x, ...)
parsed_paras(x, ...)
otoks(x, ...)
}
\arguments{
  \item{x}{a text document object.}
  \item{...}{further arguments to be passed to or from methods.}
}
\details{
  Methods for extracting POS tagged word tokens (i.e., for generics
  \code{tagged_words()}, \code{tagged_sents()} and
  \code{tagged_paras()}) can optionally provide a mechanism for mapping
  the POS tags via a \code{map} argument.  This can give a function, a
  named character vector (with names and elements the tags to map from
  and to, respectively), or a named list of such named character
  vectors, with names corresponding to POS tagsets (see
  \code{\link{Universal_POS_tags_map}} for an example).  If a list, the
  map used will be the element with name matching the POS tagset used
  (this information is typically determined from the text document
  metadata; see the the help pages for text document extension classes
  implementing this mechanism for details).

  Text document classes may provide support for representing both
  (syntactic) words (for which annotations can be provided) and
  orthographic (word) tokens, e.g., in Spanish \emph{dámelo = da me lo}.
  For these, \code{words()} gives the syntactic word tokens, and
  \code{otoks()} the orthographic word tokens.  This is currently
  supported for \link[=CoNLLUTextDocument]{CoNNL-U text documents} (see
  \url{https://universaldependencies.org/format.html} for more
  information) and \link[=AnnotatedPlainTextDocument]{annotated plain
  text documents} (via \code{word} features as used for example for some
  Stanford CoreNLP annotator pipelines provided by package
  \pkg{StanfordCoreNLP} available from the repository at
  \url{https://datacube.wu.ac.at}).

  In addition to methods for the text document classes provided by
  package \pkg{NLP} itself, (see \link{TextDocument}), package \pkg{NLP}
  also provides word tokens and POS tagged word tokens for the results
  of
  \code{\link[udpipe]{udpipe_annotate}()}
  from package \CRANpkg{udpipe},
  \code{\link[spacyr]{spacy_parse}()}
  from package \CRANpkg{spacyr},
  and
  \code{\link[cleanNLP]{cnlp_annotate}()}
  from package \CRANpkg{cleanNLP}.
}
\value{
  For \code{words()}, a character vector with the word tokens in the
  document.

  For \code{sents()}, a list of character vectors with the word tokens
  in the sentences.

  For \code{paras()}, a list of lists of character vectors with the word
  tokens in the sentences, grouped according to the paragraphs.

  For \code{tagged_words()}, a character vector with the POS tagged word
  tokens in the document (i.e., the word tokens and their POS tags,
  separated by \samp{/}).

  For \code{tagged_sents()}, a list of character vectors with the POS
  tagged word tokens in the sentences.

  For \code{tagged_paras()}, a list of lists of character vectors with
  the POS tagged word tokens in the sentences, grouped according to the
  paragraphs.
  
  For \code{chunked_sents()}, a list of (flat) \code{\link{Tree}}
  objects giving the chunk trees for the sentences in the document.

  For \code{parsed_sents()}, a list of \code{\link{Tree}}
  objects giving the parse trees for the sentences in the document.

  For \code{parsed_paras()}, a list of lists of \code{\link{Tree}}
  objects giving the parse trees for the sentences in the document,
  grouped according to the paragraphs in the document.

  For \code{otoks()}, a character vector with the orthographic word
  tokens in the document.
}
\seealso{
  \code{\link{TextDocument}} for basic information on the text document
  infrastructure employed by package \pkg{NLP}.
}
\examples{
## Example from <https://universaldependencies.org/format.html>:
d <- CoNLLUTextDocument(system.file("texts", "spanish.conllu",
                                    package = "NLP"))
content(d)
## To extract the syntactic words:
words(d)
## To extract the orthographic word tokens:
otoks(d)
}

\name{ngrams}
\alias{ngrams}
\title{Compute N-Grams}
\description{
  Compute the \eqn{n}-grams (contiguous sub-sequences of length \eqn{n})
  of a given sequence.
}
\usage{
ngrams(x, n)
}
\arguments{
  \item{x}{a sequence (vector).}
  \item{n}{a positive integer giving the length of contiguous
    sub-sequences to be computed.}
}
\value{
  a list with the computed sub-sequences.
}
\examples{
s <- "The quick brown fox jumps over the lazy dog"
## Split into words:
w <- strsplit(s, " ", fixed = TRUE)[[1L]]
## Word tri-grams:
ngrams(w, 3L)
## Word tri-grams pasted together:
vapply(ngrams(w, 3L), paste, "", collapse = " ")
}

\name{Tagged_Token}
\alias{Tagged_Token}
\alias{as.Tagged_Token}
\alias{is.Tagged_Token}
\alias{[.Tagged_Token}
%% \alias{[<-.Tagged_Token}
\alias{[[.Tagged_Token}
%% \alias{[[<-.Tagged_Token}
\alias{$<-.Tagged_Token}
\alias{as.data.frame.Tagged_Token}
\alias{as.list.Tagged_Token}
\alias{c.Tagged_Token}
\alias{duplicated.Tagged_Token}
\alias{format.Tagged_Token}
\alias{length.Tagged_Token}
\alias{names.Tagged_Token}
\alias{print.Tagged_Token}
\alias{unique.Tagged_Token}
\title{Tagged_Token objects}
\description{
  Creation and manipulation of tagged token objects.
}
\usage{
Tagged_Token(token, tag)
as.Tagged_Token(x)
is.Tagged_Token(x)
}
\arguments{
  \item{token, tag}{character vectors giving tokens and the
    corresponding tags.}
  \item{x}{an \R object.}
}
\details{
  A tagged token is a pair with \dQuote{slots} \sQuote{token} and
  \sQuote{tag}, giving the token and the corresponding tag.

  Tagged token objects provide sequences (allowing positional access) of
  single tagged tokens.  They have class \code{"Tagged_Token"}.

  Subscripting tagged token objects via \code{[} extracts subsets of
  tagged tokens; subscripting via \code{$} extracts character vectors
  with the sequence of values of the named slot.

  There are several additional methods for class \code{"Tagged_Token"}:
  \code{print()} and \code{format()} (which concatenate tokens and tags
  separated by \samp{/});
  \code{c()} combines tagged token objects (or objects coercible to
  these using \code{as.Tagged_Token()}), and
  \code{as.list()} and \code{as.data.frame()} coerce, respectively, to
  lists (of single tagged token objects) and data frames (with tagged
  tokens and slots corresponding to rows and columns).

  \code{Tagged_Token()} creates tagged token objects from the given
  sequences of tokens and tags, which must have the same length.

  \code{as.Tagged_Token()} coerces to tagged token objects, with a
  method for \code{\link{TextDocument}} objects using
  \code{\link{tagged_words}()}.

  \code{is.Tagged_Token()} tests whether an object inherits from class
  \code{"Tagged_Token"}.
}
\value{
  For \code{Tagged_Token()} and \code{as.Tagged_Token()}, a tagged token
  object (of class \code{"Tagged_Token"}).

  For \code{is.Tagged_Token()}, a logical.
}

\name{datetime}
\alias{parse_ISO_8601_datetime}
\title{Parse ISO 8601 Date/Time Strings}
\description{
  Extract date/time components from strings following one of the six
  formats specified in the NOTE-datetime ISO 8601 profile
  (\url{https://www.w3.org/TR/NOTE-datetime}).
}
\usage{
parse_ISO_8601_datetime(x)
}
\arguments{
  \item{x}{a character vector.}
}
\details{
  For character strings in one of the formats in the profile, the
  corresponding date/time components are extracted, with seconds and
  decimal fractions of seconds combined.  Other (malformed) strings are
  warned about.

  The extracted components for each string are gathered into a named
  list with elements of the appropriate type (integer for year to min;
  double for sec; character for the time zone designator).  The object
  returned is a (suitably classed) list of such named lists.  This
  internal representation may change in future versions.

  One can subscript such ISO 8601 date/time objects using \code{[} and
  extract components using \code{$} (where missing components will
  result in \code{NA}s), and convert them to the standard R date/time
  classes using \code{\link{as.Date}()}, \code{\link{as.POSIXct}()} and
  \code{\link{as.POSIXlt}()} (incomplete elements will convert to
  suitably missing elements).  In addition, there are \code{print()} and
  \code{as.data.frame()} methods for such objects.
}
\value{
  An object inheriting from class \code{"ISO_8601_datetime"} with the
  extracted date/time components.
}
\examples{
## Use the examples from <https://www.w3.org/TR/NOTE-datetime>, plus one
## in UTC.
x <- c("1997",
       "1997-07",
       "1997-07-16",
       "1997-07-16T19:20+01:00",
       "1997-07-16T19:20:30+01:00",
       "1997-07-16T19:20:30.45+01:00",
       "1997-07-16T19:20:30.45Z")
y <- parse_ISO_8601_datetime(x)
y
## Conversions: note that "incomplete" elements are converted to
## "missing".
as.Date(y)
as.POSIXlt(y)
## Subscripting and extracting components:
head(y, 3)
y$mon
}

\name{Annotation}
\alias{Annotation}
\alias{as.Annotation}
\alias{as.Annotation.Span}
\alias{is.Annotation}
\alias{[.Annotation}
%% \alias{[<-.Annotation}
\alias{[[.Annotation}
%% \alias{[[<-.Annotation}
\alias{$<-.Annotation}
\alias{as.data.frame.Annotation}
\alias{as.list.Annotation}
\alias{c.Annotation}
\alias{duplicated.Annotation}
\alias{format.Annotation}
\alias{length.Annotation}
\alias{merge.Annotation}
\alias{meta.Annotation}
\alias{meta<-.Annotation}
\alias{names.Annotation}
\alias{print.Annotation}
\alias{subset.Annotation}
\alias{unique.Annotation}
\title{Annotation objects}
\description{
  Creation and manipulation of annotation objects.
}
\usage{
Annotation(id = NULL, type = NULL, start, end, features = NULL,
           meta = list())
as.Annotation(x, ...)
\method{as.Annotation}{Span}(x, id = NULL, type = NULL, ...)
is.Annotation(x)
}
\arguments{
  \item{id}{an integer vector giving the annotation ids, or \code{NULL}
    (default) resulting in missing ids.}
  \item{type}{a character vector giving the annotation types, or
    \code{NULL} (default) resulting in missing types.}
  \item{start, end}{integer vectors giving the start and end positions
    of the character spans the annotations refer to.}
  \item{features}{a list of (named or empty) feature lists, or
    \code{NULL} (default), resulting in empty feature lists.}
  \item{meta}{a named or empty list of annotation metadata tag-value
    pairs.}
  \item{x}{an \R object (an object of class \code{"\link{Span}"} for the
    coercion methods for such objects).}
  \item{...}{further arguments passed to or from other methods.}
}
\details{
  A single annotation (of natural language text) is a quintuple with
  \dQuote{slots} \sQuote{id}, \sQuote{type}, \sQuote{start},
  \sQuote{end}, and \sQuote{features}.  These give, respectively, id and
  type, the character span the annotation refers to, and a collection of
  annotation features (tag/value pairs).

  Annotation objects provide sequences (allowing positional access) of
  single annotations, together with metadata about these.  They have
  class \code{"Annotation"} and, as they contain character spans, also
  inherit from class \code{"\link{Span}"}.  Span objects can be coerced
  to annotation objects via \code{as.Annotation()} which allows to
  specify ids and types (using the default values sets these to
  missing), and annotation objects can be coerced to span objects using
  \code{\link{as.Span}()}.

  The features of a single annotation are represented as named or empty
  lists.

  Subscripting annotation objects via \code{[} extracts subsets of
  annotations; subscripting via \code{$} extracts the sequence of values
  of the named slot, i.e., an integer vector for \sQuote{id},
  \sQuote{start}, and \sQuote{end}, a character vector for
  \sQuote{type}, and a list of named or empty lists for
  \sQuote{features}.

  There are several additional methods for class \code{"Annotation"}:
  \code{print()} and \code{format()} (which both have a \code{values}
  argument which if \code{FALSE} suppresses indicating the feature map
  values);
  \code{c()} combines annotations (or objects coercible to these using
  \code{as.Annotation()});
  \code{merge()} merges annotations by combining the feature lists of
  annotations with otherwise identical slots;
  \code{subset()} allows subsetting by expressions involving the slot
  names; and
  \code{as.list()} and \code{as.data.frame()} coerce, respectively, to
  lists (of single annotation objects) and data frames (with annotations
  and slots corresponding to rows and columns).

  \code{Annotation()} creates annotation objects from the given sequences
  of slot values: those not \code{NULL} must all have the same length
  (the number of annotations in the object).

  \code{as.Annotation()} coerces to annotation objects, with a method
  for span objects.

  \code{is.Annotation()} tests whether an object inherits from class
  \code{"Annotation"}.
}
\value{
  For \code{Annotation()} and \code{as.Annotation()}, an annotation
  object (of class \code{"Annotation"} also inheriting from class
  \code{"Span"}).

  For \code{is.Annotation()}, a logical.
}
\examples{
## A simple text.
s <- String("  First sentence.  Second sentence.  ")
##           ****5****0****5****0****5****0****5**

## Basic sentence and word token annotations for the text.
a1s <- Annotation(1 : 2,
                  rep.int("sentence", 2L),
                  c( 3L, 20L),
                  c(17L, 35L))
a1w <- Annotation(3 : 6,
                  rep.int("word", 4L),
                  c( 3L,  9L, 20L, 27L),
                  c( 7L, 16L, 25L, 34L))

## Use c() to combine these annotations:
a1 <- c(a1s, a1w)
a1
## Subscripting via '[':
a1[3 : 4]
## Subscripting via '$':
a1$type
## Subsetting according to slot values, directly:
a1[a1$type == "word"]
## or using subset():
subset(a1, type == "word")

## We can subscript string objects by annotation objects to extract the
## annotated substrings:
s[subset(a1, type == "word")]
## We can also subscript by lists of annotation objects:
s[annotations_in_spans(subset(a1, type == "word"),
                       subset(a1, type == "sentence"))]

## Suppose we want to add the sentence constituents (the ids of the
## words in the respective sentences) to the features of the sentence
## annotations.  The basic computation is
lapply(annotations_in_spans(a1[a1$type == "word"],
                            a1[a1$type == "sentence"]),
       function(a) a$id)
## For annotations, we need lists of feature lists:
features <-
    lapply(annotations_in_spans(a1[a1$type == "word"],
                                a1[a1$type == "sentence"]),
           function(e) list(constituents = e$id))
## Could add these directly:
a2 <- a1
a2$features[a2$type == "sentence"] <- features
a2
## Note how the print() method summarizes the features.
## We could also write a sentence constituent annotator
## (note that annotators should always have formals 's' and 'a', even
## though for computing the sentence constituents s is not needed):
sent_constituent_annotator <-
Annotator(function(s, a) {
              i <- which(a$type == "sentence")
              features <-
                  lapply(annotations_in_spans(a[a$type == "word"],
                                              a[i]),
                        function(e) list(constituents = e$id))
              Annotation(a$id[i], a$type[i], a$start[i], a$end[i],
                         features)
         })
sent_constituent_annotator(s, a1)
## Can use merge() to merge the annotations:
a2 <- merge(a1, sent_constituent_annotator(s, a1))
a2
## Equivalently, could have used
a2 <- annotate(s, sent_constituent_annotator, a1)
a2
## which merges automatically.
}

\name{utils}
\alias{next_id}
\alias{single_feature}
\title{Annotation Utilities}
\description{Utilities for creating annotation objects.}
\usage{
next_id(id)
single_feature(value, tag)
}
\arguments{
  \item{id}{an integer vector of annotation ids.}
  \item{value}{an \R object.}
  \item{tag}{a character string.}
}
\details{
  \code{next_id()} obtains the next \dQuote{available} id based on the
  given annotation ids (one more than the maximal non-missing id).

  \code{single_feature()} creates a single feature from the given value
  and tag (i.e., a named list with the value named by the tag).
}

\name{TextDocument}
\alias{TextDocument}
\title{Text Documents}
\description{
  Representing and computing on text documents.
}
\details{
  \emph{Text documents} are documents containing (natural language)
  text.  In packages which employ the infrastructure provided by package
  \pkg{NLP}, such documents are represented via the virtual S3 class
  \code{"TextDocument"}: such packages then provide S3 text document
  classes extending the virtual base class (such as the
  \code{\link{AnnotatedPlainTextDocument}} objects provided by package
  \pkg{NLP} itself).

  All extension classes must provide an \code{\link{as.character}()}
  method which extracts the natural language text in documents of the
  respective classes in a \dQuote{suitable} (not necessarily structured)
  form, as well as \code{\link{content}()} and \code{\link{meta}()}
  methods for accessing the (possibly raw) document content and metadata.

  In addition, the infrastructure features the generic functions
  \code{\link{words}()}, \code{\link{sents}()}, etc., for which
  extension classes can provide methods giving a structured view of the
  text contained in documents of these classes (returning, e.g., a
  character vector with the word tokens in these documents, and a list
  of such character vectors).
}
\seealso{
  \code{\link{AnnotatedPlainTextDocument}},
  \code{\link{CoNLLTextDocument}},
  \code{\link{CoNLLUTextDocument}},
  \code{\link{TaggedTextDocument}}, and
  \code{\link{WordListDocument}}
  for the text document classes provided by package \pkg{NLP}.
}

\name{tokenizers}
\alias{Regexp_Tokenizer}
\alias{blankline_tokenizer}
\alias{whitespace_tokenizer}
\alias{wordpunct_tokenizer}
\title{Regexp tokenizers}
\description{
  Tokenizers using regular expressions to match either tokens or
  separators between tokens.
}
\usage{
Regexp_Tokenizer(pattern, invert = FALSE, ..., meta = list())
blankline_tokenizer(s)
whitespace_tokenizer(s)
wordpunct_tokenizer(s)
}
\arguments{
  \item{pattern}{a character string giving the regular expression to use
    for matching.}
  \item{invert}{a logical indicating whether to match separators between
    tokens.}
  \item{...}{further arguments to be passed to \code{\link{gregexpr}()}.}
  \item{meta}{a named or empty list of tokenizer metadata tag-value
    pairs.}
  \item{s}{a \code{\link{String}} object, or something coercible to this
    using \code{\link{as.String}()} (e.g., a character string with
    appropriate encoding information).}
}
\details{
  \code{Regexp_Tokenizer()} creates regexp span tokenizers which use the
  given \code{pattern} and \code{...} arguments to match tokens or
  separators between tokens via \code{\link{gregexpr}()}, and then
  transform the results of this into character spans of the tokens
  found.

  \code{whitespace_tokenizer()} tokenizes by treating any sequence of
  whitespace characters as a separator.

  \code{blankline_tokenizer()} tokenizes by treating any sequence of
  blank lines as a separator.

  \code{wordpunct_tokenizer()} tokenizes by matching sequences of
  alphabetic characters and sequences of (non-whitespace) non-alphabetic
  characters.
}
\value{
  \code{Regexp_Tokenizer()} returns the created regexp span tokenizer.

  \code{blankline_tokenizer()}, \code{whitespace_tokenizer()} and
  \code{wordpunct_tokenizer()} return the spans of the tokens found in
  \code{s}.
}
\seealso{
  \code{\link{Span_Tokenizer}()} for general information on span
  tokenizer objects.
}
\examples{
## A simple text.
s <- String("  First sentence.  Second sentence.  ")
##           ****5****0****5****0****5****0****5**

spans <- whitespace_tokenizer(s)
spans
s[spans]

spans <- wordpunct_tokenizer(s)
spans
s[spans]
}

\name{annotators}
\alias{Simple_Para_Token_Annotator}
\alias{Simple_Sent_Token_Annotator}
\alias{Simple_Word_Token_Annotator}
\alias{Simple_POS_Tag_Annotator}
\alias{Simple_Entity_Annotator}
\alias{Simple_Chunk_Annotator}
\alias{Simple_Stem_Annotator}
\alias{Simple annotator generators}
\title{Simple annotator generators}
\description{
  Create annotator objects for composite basic NLP tasks based on
  functions performing simple basic tasks.
}
\usage{
Simple_Para_Token_Annotator(f, meta = list(), classes = NULL)
Simple_Sent_Token_Annotator(f, meta = list(), classes = NULL)
Simple_Word_Token_Annotator(f, meta = list(), classes = NULL)
Simple_POS_Tag_Annotator(f, meta = list(), classes = NULL)
Simple_Entity_Annotator(f, meta = list(), classes = NULL)
Simple_Chunk_Annotator(f, meta = list(), classes = NULL)
Simple_Stem_Annotator(f, meta = list(), classes = NULL)
}
\arguments{
  \item{f}{a function performing a \dQuote{simple} basic NLP task (see
    \bold{Details}).}
  \item{meta}{an empty or named list of annotator (pipeline) metadata
    tag-value pairs.}
  \item{classes}{a character vector or \code{NULL} (default) giving
    classes to be used for the created annotator object in addition to
    the default ones (see \bold{Details}).}
}
\details{
  The purpose of these functions is to facilitate the creation of
  annotators for basic NLP tasks as described below.

  \code{Simple_Para_Token_Annotator()} creates \dQuote{simple} paragraph
  token annotators.  Argument \code{f} should be a paragraph tokenizer,
  which takes a string \code{s} with the whole text to be processed, and
  returns the spans of the paragraphs in \code{s}, or an annotation
  object with these spans and (possibly) additional features.  The
  generated annotator inherits from the default classes
  \code{"Simple_Para_Token_Annotator"} and \code{"Annotator"}.  It uses
  the results of the simple paragraph tokenizer to create and return
  annotations with unique ids and type \sQuote{paragraph}.
  
  \code{Simple_Sent_Token_Annotator()} creates \dQuote{simple} sentence
  token annotators.  Argument \code{f} should be a sentence tokenizer,
  which takes a string \code{s} with the whole text to be processed, and
  returns the spans of the sentences in \code{s}, or an annotation
  object with these spans and (possibly) additional features.  The
  generated annotator inherits from the default classes
  \code{"Simple_Sent_Token_Annotator"} and \code{"Annotator"}.  It uses
  the results of the simple sentence tokenizer to create and return
  annotations with unique ids and type \sQuote{sentence}, possibly
  combined with sentence constituent features for already available
  paragraph annotations.

  \code{Simple_Word_Token_Annotator()} creates \dQuote{simple} word
  token annotators.  Argument \code{f} should be a simple word
  tokenizer, which takes a string \code{s} giving a sentence to be
  processed, and returns the spans of the word tokens in \code{s}, or an 
  annotation object with these spans and (possibly) additional features.
  The generated annotator inherits from the default classes
  \code{"Simple_Word_Token_Annotator"} and \code{"Annotator"}.
  It uses already available sentence token annotations to extract the
  sentences and obtains the results of the word tokenizer for these.  It
  then adds the sentence character offsets and unique word token ids,
  and word token constituents features for the sentences, and returns
  the word token annotations combined with the augmented sentence token
  annotations.

  \code{Simple_POS_Tag_Annotator()} creates \dQuote{simple} POS tag
  annotators.  Argument \code{f} should be a simple POS tagger, which
  takes a character vector giving the word tokens in a sentence, and
  returns either a character vector with the tags, or a list of feature
  maps with the tags as \sQuote{POS} feature and possibly other
  features.  The generated annotator inherits from the default classes
  \code{"Simple_POS_Tag_Annotator"} and \code{"Annotator"}.  It uses
  already available sentence and word token annotations to extract the
  word tokens for each sentence and obtains the results of the simple
  POS tagger for these, and returns annotations for the word tokens with
  the features obtained from the POS tagger.

  \code{Simple_Entity_Annotator()} creates \dQuote{simple} entity
  annotators.  Argument \code{f} should be a simple entity detector
  (\dQuote{named entity recognizer}) which takes a character vector
  giving the word tokens in a sentence, and return an annotation object
  with the \emph{word} token spans, a \sQuote{kind} feature giving the
  kind of the entity detected, and possibly other features.  The
  generated annotator inherits from the default classes
  \code{"Simple_Entity_Annotator"} and \code{"Annotator"}.  It uses
  already available sentence and word token annotations to extract the
  word tokens for each sentence and obtains the results of the simple
  entity detector for these, transforms word token spans to character
  spans and adds unique ids, and returns the combined entity
  annotations.
  
  \code{Simple_Chunk_Annotator()} creates \dQuote{simple} chunk
  annotators.  Argument \code{f} should be a simple chunker, which takes
  as arguments character vectors giving the word tokens and the
  corresponding POS tags, and returns either a character vector with the
  chunk tags, or a list of feature lists with the tags as
  \sQuote{chunk_tag} feature and possibly other features.  The generated
  annotator inherits from the default classes
  \code{"Simple_Chunk_Annotator"} and \code{"Annotator"}.  It uses
  already available annotations to extract the word tokens and POS tags
  for each sentence and obtains the results of the simple chunker for
  these, and returns word token annotations with the chunk features
  (only).

  \code{Simple_Stem_Annotator()} creates \dQuote{simple} stem
  annotators.  Argument \code{f} should be a simple stemmer, which takes
  as arguments a character vector giving the word tokens, and returns a
  character vector with the corresponding word stems.  The generated
  annotator inherits from the default classes
  \code{"Simple_Stem_Annotator"} and \code{"Annotator"}.  It uses
  already available annotations to extract the word tokens, and returns
  word token annotations with the corresponding stem features (only).

  In all cases, if the underlying simple processing function returns
  annotation objects these should not provide their own ids (or use such
  in the features), as the generated annotators will necessarily provide
  these (the already available annotations are only available at the
  annotator level, but not at the simple processing level).
}
\value{
  An annotator object inheriting from the given classes and the default
  ones.
}
\seealso{
  Package \pkg{openNLP} which provides annotator generators for sentence
  and word tokens, POS tags, entities and chunks, using processing
  functions based on the respective Apache OpenNLP MaxEnt processing
  resources.
}
\examples{
## A simple text.
s <- String("  First sentence.  Second sentence.  ")
##           ****5****0****5****0****5****0****5**

## A very trivial sentence tokenizer.
sent_tokenizer <-
function(s) {
    s <- as.String(s)
    m <- gregexpr("[^[:space:]][^.]*\\\\.", s)[[1L]]
    Span(m, m + attr(m, "match.length") - 1L)
}
## (Could also use Regexp_Tokenizer() with the above regexp pattern.)
sent_tokenizer(s)
## A simple sentence token annotator based on the sentence tokenizer.
sent_token_annotator <- Simple_Sent_Token_Annotator(sent_tokenizer)
sent_token_annotator
a1 <- annotate(s, sent_token_annotator)
a1
## Extract the sentence tokens.
s[a1]

## A very trivial word tokenizer.
word_tokenizer <-
function(s) {
    s <- as.String(s)
    ## Remove the last character (should be a period when using
    ## sentences determined with the trivial sentence tokenizer).
    s <- substring(s, 1L, nchar(s) - 1L)
    ## Split on whitespace separators.
    m <- gregexpr("[^[:space:]]+", s)[[1L]]
    Span(m, m + attr(m, "match.length") - 1L)
}
lapply(s[a1], word_tokenizer)
## A simple word token annotator based on the word tokenizer.
word_token_annotator <- Simple_Word_Token_Annotator(word_tokenizer)
word_token_annotator
a2 <- annotate(s, word_token_annotator, a1)
a2
## Extract the word tokens.
s[subset(a2, type == "word")]

## A simple word token annotator based on wordpunct_tokenizer():
word_token_annotator <-
    Simple_Word_Token_Annotator(wordpunct_tokenizer,
                                list(description =
                                     "Based on wordpunct_tokenizer()."))
word_token_annotator
a2 <- annotate(s, word_token_annotator, a1)
a2
## Extract the word tokens.
s[subset(a2, type == "word")]
}

\name{features}
\alias{features}
\title{Extract Annotation Features}
\description{
  Conveniently extract features from annotations and annotated plain
  text documents.
}
\usage{
features(x, type = NULL, simplify = TRUE)
}
\arguments{
  \item{x}{an object inheriting from class \code{"Annotation"} or
    \code{"AnnotatedPlainTextDocument"}.}
  \item{type}{a character vector of annotation types to be used for
    selecting annotations, or \code{NULL} (default) to use all
    annotations.  When selecting, the elements of \code{type} will
    partially be matched against the annotation types.}
  \item{simplify}{a logical indicating whether to simplify feature
    values to a vector.}
}
\details{
  \code{features()} conveniently gathers all feature tag-value pairs in
  the selected annotations into a data frame with variables the values
  for all tags found (using a \code{NULL} value for tags without a
  value).  In general, variables will be \emph{lists} of extracted
  values.  By default, variables where all elements are length one
  atomic vectors are simplified into an atomic vector of values.  The
  values for specific tags can be extracted by suitably subscripting the
  obtained data frame. 
}
\examples{
## Use a pre-built annotated plain text document,
## see ? AnnotatedPlainTextDocument.
d <- readRDS(system.file("texts", "stanford.rds", package = "NLP"))
## Extract features of all *word* annotations in doc:
x <- features(d, "word")
## Could also have abbreviated "word" to "w".
x
## Only lemmas:
x$lemma
## Words together with lemmas:
paste(words(d), x$lemma, sep = "/")
}

\name{tagsets}
\alias{Penn_Treebank_POS_tags}
\alias{Brown_POS_tags}
\alias{Universal_POS_tags}
\alias{Universal_POS_tags_map}
\title{NLP Tag Sets}
\description{
  Tag sets frequently used in Natural Language Processing.
}
\usage{
Penn_Treebank_POS_tags
Brown_POS_tags
Universal_POS_tags
Universal_POS_tags_map
}
\details{
  \code{Penn_Treebank_POS_tags} and \code{Brown_POS_tags} provide,
  respectively, the Penn Treebank POS tags
  (\url{https://catalog.ldc.upenn.edu/docs/LDC95T7/cl93.html}, Table 2)
  and the POS tags used for the Brown corpus
  (\url{https://en.wikipedia.org/wiki/Brown_Corpus}),
  both as data frames with the following variables:
  \describe{
    \item{entry}{a character vector with the POS tags}
    \item{description}{a character vector with short descriptions of the
      tags}
    \item{examples}{a character vector with examples for the tags}
  }

  \code{Universal_POS_tags} provides the universal POS tagset introduced
  by Slav Petrov, Dipanjan Das, and Ryan McDonald
  (\doi{10.48550/arXiv.1104.2086}), as a data frame with character
  variables \code{entry} and \code{description}.

  \code{Universal_POS_tags_map} is a named list of mappings from
  language and treebank specific POS tagsets to the universal POS tags,
  with elements named \samp{en-ptb} and \samp{en-brown} giving the
  mappings, respectively, for the Penn Treebank and Brown POS tags.
}
\source{
  \url{https://catalog.ldc.upenn.edu/docs/LDC95T7/cl93.html},
  % As of 2024-07, \url{http://www.hit.uib.no/icame/brown/bcm.html} no
  % longer works, so use the download info from Wikipedia.
  \url{http://www.nltk.org/nltk_data/},
  \url{https://github.com/slavpetrov/universal-pos-tags}.
}
\examples{
## Penn Treebank POS tags
dim(Penn_Treebank_POS_tags)
## Inspect first 20 entries:
write.dcf(head(Penn_Treebank_POS_tags, 20L))

## Brown POS tags
dim(Brown_POS_tags)
## Inspect first 20 entries:
write.dcf(head(Brown_POS_tags, 20L))

## Universal POS tags
Universal_POS_tags

## Available mappings to universal POS tags
names(Universal_POS_tags_map)
}

\name{WordListDocument}
\alias{WordListDocument}
\title{Word List Text Documents}
\description{
  Create text documents from word lists.
}
\usage{
WordListDocument(con, encoding = "unknown", meta = list())
}
\arguments{
  \item{con}{a connection object or a character string.
    See \code{\link{readLines}()} for details.
  }
  \item{encoding}{encoding to be assumed for input strings.
    See \code{\link{readLines}()} for details.
  }
  \item{meta}{a named or empty list of document metadata tag-value
    pairs.}
}
\details{
  \code{WordListDocument()} uses \code{\link{readLines}()} to read
  collections of words from connections for which each line provides one
  word, with blank lines ignored, and returns a word list document
  object which inherits from classes \code{"WordListDocument"} and
  \code{"\link{TextDocument}"}.

  The methods for generics \code{\link{words}()} and
  \code{\link{as.character}()} and class \code{"WordListDocument"}
  can be used to extract the words.
}
\value{
  A word list document object inheriting from \code{"WordListDocument"}
  and \code{"\link{TextDocument}"}.
}  
\seealso{
  \code{\link{TextDocument}} for basic information on the text document
  infrastructure employed by package \pkg{NLP}.
}

\name{Span}
\alias{Span}
\alias{as.Span}
\alias{is.Span}
\alias{[.Span}
%% \alias{[<-.Span}
\alias{[[.Span}
%% \alias{[[<-.Span}
\alias{$<-.Span}
\alias{Ops.Span}
\alias{as.data.frame.Span}
\alias{as.list.Span}
\alias{c.Span}
\alias{duplicated.Span}
\alias{format.Span}
\alias{length.Span}
\alias{names.Span}
\alias{print.Span}
\alias{unique.Span}
\title{Span objects}
\description{
  Creation and manipulation of span objects.
}
\usage{
Span(start, end)
as.Span(x)
is.Span(x)
}
\arguments{
  \item{start, end}{integer vectors giving the start and end positions
    of the spans.}
  \item{x}{an \R object.}
}
\details{
  A single span is a pair with \dQuote{slots} \sQuote{start} and
  \sQuote{end}, giving the start and end positions of the span.

  Span objects provide sequences (allowing positional access) of single
  spans.  They have class \code{"Span"}.  Span objects can be coerced to
  annotation objects via \code{\link{as.Annotation}()} (which of course is
  only appropriate provided that the spans are character spans of the
  natural language text being annotated), and annotation objects can be
  coerced to span objects via \code{as.Span()} (giving the character spans
  of the annotations).

  Subscripting span objects via \code{[} extracts subsets of spans;
  subscripting via \code{$} extracts integer vectors with the sequence
  of values of the named slot.

  There are several additional methods for class \code{"Span"}:
  \code{print()} and \code{format()};
  \code{c()} combines spans (or objects coercible to these using
  \code{as.Span()}), and
  \code{as.list()} and \code{as.data.frame()} coerce, respectively, to
  lists (of single span objects) and data frames (with spans and slots
  corresponding to rows and columns).  Finally, one can add a scalar and
  a span object (resulting in shifting the start and end positions by
  the scalar).

  \code{Span()} creates span objects from the given sequences of start
  and end positions, which must have the same length.

  \code{as.Span()} coerces to span objects, with a method for annotation
  objects.

  \code{is.Span()} tests whether an object inherits from class
  \code{"Span"} (and hence returns \code{TRUE} for both span and
  annotation objects).
}
\value{
  For \code{Span()} and \code{as.Span()}, a span object (of class
  \code{"Span"}).

  For \code{is.Span()}, a logical.
}

\name{annotate}
\alias{annotate}
\title{Annotate text strings}
\description{
  Compute annotations by iteratively calling the given annotators with
  the given text and current annotations, and merging the newly computed
  annotations with the current ones.
}
\usage{
annotate(s, f, a = Annotation())
}
\arguments{
  \item{s}{a \code{\link{String}} object, or something coercible to this
    using \code{\link{as.String}} (e.g., a character string with
    appropriate encoding information).}
  \item{f}{an \code{\link{Annotator}} or
    \code{\link{Annotator_Pipeline}} object, or something coercible to
    the latter via \code{\link{as.Annotator_Pipeline}()} (such as a list
    of annotator objects).}
  \item{a}{an \code{\link{Annotation}} object giving the annotations to
    start with.}
}
\value{
  An \code{\link{Annotation}} object containing the iteratively computed
  and merged annotations.
}
\examples{
## A simple text.
s <- String("  First sentence.  Second sentence.  ")
##           ****5****0****5****0****5****0****5**

## A very trivial sentence tokenizer.
sent_tokenizer <-
function(s) {
    s <- as.String(s)
    m <- gregexpr("[^[:space:]][^.]*\\\\.", s)[[1L]]
    Span(m, m + attr(m, "match.length") - 1L)
}
## (Could also use Regexp_Tokenizer() with the above regexp pattern.)
## A simple sentence token annotator based on the sentence tokenizer.
sent_token_annotator <- Simple_Sent_Token_Annotator(sent_tokenizer)

## Annotate sentence tokens.
a1 <- annotate(s, sent_token_annotator)
a1

## A very trivial word tokenizer.
word_tokenizer <-
function(s) {
    s <- as.String(s)
    ## Remove the last character (should be a period when using
    ## sentences determined with the trivial sentence tokenizer).
    s <- substring(s, 1L, nchar(s) - 1L)
    ## Split on whitespace separators.
    m <- gregexpr("[^[:space:]]+", s)[[1L]]
    Span(m, m + attr(m, "match.length") - 1L)
}
## A simple word token annotator based on the word tokenizer.
word_token_annotator <- Simple_Word_Token_Annotator(word_tokenizer)

## Annotate word tokens using the already available sentence token
## annotations.
a2 <- annotate(s, word_token_annotator, a1)
a2

## Can also perform sentence and word token annotations in a pipeline:
p <- Annotator_Pipeline(sent_token_annotator, word_token_annotator)
annotate(s, p)
}

\name{CoNLLTextDocument}
\alias{CoNLLTextDocument}
\title{CoNLL-Style Text Documents}
\description{
  Create text documents from CoNLL-style files.
}
\usage{
CoNLLTextDocument(con, encoding = "unknown", format = "conll00",
                  meta = list())
}
\arguments{
  \item{con}{a connection object or a character string.
    See \code{\link{scan}()} for details.
  }
  \item{encoding}{encoding to be assumed for input strings.
    See \code{\link{scan}()} for details.
  }
  \item{format}{a character vector specifying the format.
    See \bold{Details}.
  }
  \item{meta}{a named or empty list of document metadata tag-value
    pairs.}
}
\details{
  CoNLL-style files use an extended tabular format where empty lines
  separate sentences, and non-empty lines consist of whitespace
  separated columns giving the word tokens and annotations for these.
  Such formats were popularized through their use for the shared tasks
  of CoNLL (Conference on Natural Language Learning), the yearly meeting
  of the Special Interest Group on Natural Language Learning of the
  Association for Computational Linguistics (see
  \url{https://www.signll.org/content/conll/}
  for more information about CoNLL).
  
  The precise format can vary according to corpus, and must be specified
  via argument \code{format}, as either a character string giving a
  pre-defined format, or otherwise a character vector with elements
  giving the names of the \sQuote{fields} (columns), and names used to
  give the field \sQuote{types}, with \sQuote{WORD}, \sQuote{POS} and
  \sQuote{CHUNK} to be used for, respectively, word tokens, POS tags, and
  chunk tags.  For example, \preformatted{  c(WORD = "WORD", POS = "POS", CHUNK = "CHUNK")}
  would be a format specification appropriate for the CoNLL-2000
  chunking task, as also available as the pre-defined \code{"conll00"},
  which serves as default format for reasons of back-compatibility.
  Other pre-defined formats are \code{"conll01"} (for the CoNLL-2001
  clause identification task), \code{"conll02"} (for the CoNLL-2002
  language-independent named entity recognition task), \code{"conllx"}
  (for the CoNLL-X format used in at least the CoNLL-2006 and CoNLL-2007
  multilingual dependency parsing tasks), and \code{"conll09"} (for the
  CoNLL-2009 shared task on syntactic and semantic dependencies in
  multiple languages).

  The lines are read from the given connection and split into fields
  using \code{\link{scan}()}.  From this, a suitable representation of
  the provided information is obtained, and returned as a CoNLL text
  document object inheriting from classes \code{"CoNLLTextDocument"} and
  \code{"\link{TextDocument}"}.

  There are methods for class \code{"CoNLLTextDocument"} and generics
  \code{\link{words}()},
  \code{\link{sents}()},
  \code{\link{tagged_words}()},
  \code{\link{tagged_sents}()}, and
  \code{\link{chunked_sents}()}
  (as well as \code{\link{as.character}()}),
  which should be used to access the text in such text document
  objects.

  The methods for generics
  \code{\link{tagged_words}()} and
  \code{\link{tagged_sents}()}
  provide a mechanism for mapping POS tags via the \code{map} argument,
  see section \bold{Details} in the help page for
  \code{\link{tagged_words}()} for more information.
  The POS tagset used will be inferred from the \code{POS_tagset}
  metadata element of the CoNLL-style text document.
}
\value{
  An object inheriting from \code{"CoNLLTextDocument"} and
  \code{"\link{TextDocument}"}.
}
\seealso{
  \code{\link{TextDocument}} for basic information on the text document
  infrastructure employed by package \pkg{NLP}.

  %% As of 2026-07-13,
  %% \url{https://www.clips.uantwerpen.be/conll2000/chunking/}
  %% no longer works ...
  \url{https://github.com/teropa/nlp/tree/master/resources/corpora/conll2000}
  for the CoNLL-2000 chunking task, and training and test data sets
  which can be read in using \code{CoNLLTextDocument()}.
}

\name{CoNLLUTextDocument}
\alias{CoNLLUTextDocument}
\alias{read_CoNNLU}
\title{
  CoNNL-U Text Documents
}
\description{
  Create text documents from CoNNL-U format files.
}
\usage{
CoNLLUTextDocument(con, meta = list(), text = NULL)
read_CoNNLU(con)
}
\arguments{
  \item{con}{a connection object or a character string.
    See \code{\link{scan}()} for details.
  }
  \item{meta}{a named or empty list of document metadata tag-value
    pairs.}
  \item{text}{a character vector giving the text of the CoNNL-U
    annotation.  If \code{NULL}, the \code{text} comments of the
    annotation are used.}
}
\details{
  The CoNLL-U format (see
  \url{https://universaldependencies.org/format.html})
  is a CoNLL-style format for annotated texts popularized and employed
  by the Universal Dependencies project
  (see \url{https://universaldependencies.org/}).
  For each \dQuote{word} in the text, this provides exactly the 10
  fields
  \code{ID},
  \code{FORM} (word form or punctuation symbol),
  \code{LEMMA} (lemma or stem of word form),
  \code{UPOSTAG} (universal part-of-speech tag, see
  \url{https://universaldependencies.org/u/pos/index.html}),
  \code{XPOSTAG} (language-specific part-of-speech tag, may be
  unavailable),
  \code{FEATS} (list of morphological features),
  \code{HEAD},
  \code{DEPREL},
  \code{DEPS}, and
  \code{MISC}.

  \code{read_CoNNLU()} reads the lines with these fields and optional
  comments from the given connection and splits into fields using
  \code{\link{scan}()}.  This is combined with consecutive sentence ids
  into a data frame inheriting from class \code{"CoNNLU_Annotation"}
  used for representing the annotation information,

  \code{CoNLLUTextDocument()} combines this annotation information with
  the given metadata (and optionally the original pre-tokenized text)
  into a CoNLL-U text document inheriting from classes
  \code{"CoNLLUTextDocument"} and \code{"\link{TextDocument}"}.

  The complete annotation information data frame can be extracted via
  \code{content()}.  CoNLL-U v2 requires providing the complete texts of
  each sentence (or a reconstruction thereof) in \samp{# text =} comment
  lines.  Where consistently provided, these are made available in the
  \code{text} attribute of the content data frame.

  In addition, there are methods for generics
  \code{\link{as.character}()},
  \code{\link{words}()},
  \code{\link{sents}()},
  \code{\link{tagged_words}()}, and
  \code{\link{tagged_sents}()}
  and class \code{"CoNLLUTextDocument"},
  which should be used to access the text in such text document
  objects.
  
  The CoNLL-U format allows to represent both words and (multiword)
  tokens (see section \sQuote{Words, Tokens and Empty Nodes} in the
  format documentation), as distinguished by ids being integers or
  integer ranges, with the words being annotated further.  One can
  use \code{as.character()} to extract the \emph{tokens}; all other
  viewers listed above use the \emph{words}.  Finally, the viewers
  incorporating POS tags take a \code{which} argument to specify using
  the universal or language-specific tags, by giving a substring of
  \code{"UPOSTAG"} (default) or \code{"XPOSTAG"}.
}
\value{
  For \code{CoNLLUTextDocument()}, an object inheriting from
  \code{"CoNLLUTextDocument"} and \code{"\link{TextDocument}"}.

  For \code{read_CoNNLU()}, an object inherting from
  \code{"CoNNLU_Annotation"} and \code{"\link{data.frame}"}
}
\seealso{
  \code{\link{TextDocument}} for basic information on the text document
  infrastructure employed by package \pkg{NLP}.

  \url{https://universaldependencies.org/} for access to the Universal
  Dependencies treebanks, which provide annotated texts in \emph{many}
  different languages using CoNLL-U format.
}

\name{language}
\alias{parse_IETF_language_tag}
\alias{language}
\title{Parse IETF Language Tag}
\description{
  Extract language, script, region and variant subtags from IETF
  language tags.
}
\usage{parse_IETF_language_tag(x, expand = FALSE, strict = TRUE)}
\arguments{
  \item{x}{a character vector with IETF language tags.}
  \item{expand}{a logical indicating whether to expand subtags into
    their description(s).}
  \item{strict}{a logical indicating whether invalid language tags
    should result in an error (default) or not.}
}
\details{
  Internet Engineering Task Force (IETF) language tags are defined by
  \href{https://www.rfc-editor.org/info/bcp47}{IETF BCP 47},
  which is currently composed by the normative
  \href{https://datatracker.ietf.org/doc/html/rfc5646}{RFC 5646} and
  \href{https://datatracker.ietf.org/doc/html/rfc4647}{RFC 4647},
  along with the normative content of the
  \href{https://www.iana.org/assignments/language-subtag-registry/}{IANA Language Subtag Registry}
  regulated by these RFCs.
  These tags are used in a number of modern computing standards.

  Each language tag is composed of one or more \dQuote{subtags}
  separated by hyphens.  Normal language tags have the following
  subtags:
  \itemize{
    \item a language subtag (optionally, with language extension
    subtags),
    \item an optional script subtag,
    \item an optional region subtag,
    \item optional variant subtags,
    \item optional extension subtags,
    \item an optional private use subtag.
  }
  Language subtags are mainly derived from ISO 639-1 and ISO 639-2,
  script subtags from ISO 15924, and region subtags from ISO 3166-1
  alpha-2 and UN M.49, see package \pkg{ISOcodes} for more information
  about these standards.  Variant subtags are not derived from any
  standard.  The Language Subtag Registry
  (\url{https://www.iana.org/assignments/language-subtag-registry}),
  maintained by the Internet Assigned Numbers Authority (IANA), lists
  the current valid public subtags, as well as the so-called
  \dQuote{grandfathered} language tags.

  See \url{https://en.wikipedia.org/wiki/IETF_language_tag} for more
  information.
}
\value{
  If \code{expand} is false, a list of character vectors of the form
  \code{"\var{type}=\var{subtag}"}, where \var{type} gives the type of
  the corresponding subtag (one of \sQuote{Language}, \sQuote{Extlang},
  \sQuote{Script}, \sQuote{Region}, \sQuote{Variant}, or
  \sQuote{Extension}), or \code{"\var{type}=\var{tag}"} with \var{type}
  either \sQuote{Privateuse} or \sQuote{Grandfathered}.

  Otherwise, a list of lists of character vectors obtained by replacing
  the subtags by their corresponding descriptions (which may be
  multiple) from the IANA registry.  Note that no such descriptions for
  Extension and Privateuse subtags are available in the registry; on the
  other hand, empty expansions of the other subtags indicate malformed
  tags (as these subtags must be available in the registry).
}
\examples{
## German as used in Switzerland:
parse_IETF_language_tag("de-CH")
## Serbian written using Latin script as used in Serbia and Montenegro:
parse_IETF_language_tag("sr-Latn-CS")
## Spanish appropriate to the UN Latin American and Caribbean region:
parse_IETF_language_tag("es-419")
## All in one:
parse_IETF_language_tag(c("de-CH", "sr-Latn-CS", "es-419"))
parse_IETF_language_tag(c("de-CH", "sr-Latn-CS", "es-419"),
                        expand = TRUE)
## Two grandfathered tags:
parse_IETF_language_tag(c("i-klingon", "zh-min-nan"),
                        expand = TRUE)
}
\keyword{utilities}

\name{TaggedTextDocument}
\alias{TaggedTextDocument}
\title{POS-Tagged Word Text Documents}
\description{
  Create text documents from files containing POS-tagged words.
}
\usage{
TaggedTextDocument(con, encoding = "unknown",
                   word_tokenizer = whitespace_tokenizer,
                   sent_tokenizer = Regexp_Tokenizer("\n", invert = TRUE),
                   para_tokenizer = blankline_tokenizer,
                   sep = "/",
                   meta = list())
}
\arguments{
  \item{con}{a connection object or a character string.
    See \code{\link{readLines}()} for details.
  }
  \item{encoding}{encoding to be assumed for input strings.
    See \code{\link{readLines}()} for details.
  }
  \item{word_tokenizer}{a function for obtaining the word token spans.}
  \item{sent_tokenizer}{a function for obtaining the sentence token
    spans.}
  \item{para_tokenizer}{a function for obtaining the paragraph token
    spans, or \code{NULL} in which case no paragraph tokenization is
    performed.}
  \item{sep}{the character string separating the word tokens and their
    POS tags.}
  \item{meta}{a named or empty list of document metadata tag-value
    pairs.}
}
\details{
  \code{TaggedTextDocument()} creates documents representing natural
  language text as suitable collections of POS-tagged words, based on
  using \code{\link{readLines}()} to read text lines from connections
  providing such collections.

  The text read is split into paragraph, sentence and tagged word tokens
  using the span tokenizers specified by arguments
  \code{para_tokenizer}, \code{sent_tokenizer} and
  \code{word_tokenizer}.  By default, paragraphs are assumed to be
  separated by blank lines, sentences by newlines and tagged word tokens
  by whitespace.  Finally, word tokens and their POS tags are obtained
  by splitting the tagged word tokens according to \code{sep}.  From
  this, a suitable representation of the provided collection of
  POS-tagged words is obtained, and returned as a tagged text document
  object inheriting from classes \code{"TaggedTextDocument"} and
  \code{"\link{TextDocument}"}.

  There are methods for generics
  \code{\link{words}()},
  \code{\link{sents}()},
  \code{\link{paras}()},
  \code{\link{tagged_words}()},
  \code{\link{tagged_sents}()}, and
  \code{\link{tagged_paras}()}
  (as well as \code{\link{as.character}()})
  and class \code{"TaggedTextDocument"},
  which should be used to access the text in such text document
  objects.

  The methods for generics
  \code{\link{tagged_words}()}, 
  \code{\link{tagged_sents}()} and
  \code{\link{tagged_paras}()}
  provide a mechanism for mapping POS tags via the \code{map} argument,
  see section \bold{Details} in the help page for
  \code{\link{tagged_words}()} for more information.
  The POS tagset used will be inferred from the \code{POS_tagset}
  metadata element of the CoNLL-style text document.
}
\value{
  A tagged text document object inheriting from
  \code{"TaggedTextDocument"} and \code{"\link{TextDocument}"}.
}
\seealso{
  \url{https://www.nltk.org/nltk_data/packages/corpora/brown.zip}
  which provides the W. N. Francis and H. Kucera Brown tagged word
  corpus as an archive of files which can be read in using
  \code{TaggedTextDocument()}.

  Package \pkg{tm.corpus.Brown} available from the repository at
  \url{https://datacube.wu.ac.at} conveniently provides this corpus
  as a \pkg{tm} \link[tm]{VCorpus} of tagged text documents.
}
